xref: /titanic_41/usr/src/tools/scripts/nightly.sh (revision 182c91496a82a606d31c680cedf9351196cc76e6)
1#!/bin/ksh -p
2#
3# CDDL HEADER START
4#
5# The contents of this file are subject to the terms of the
6# Common Development and Distribution License (the "License").
7# You may not use this file except in compliance with the License.
8#
9# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
10# or http://www.opensolaris.org/os/licensing.
11# See the License for the specific language governing permissions
12# and limitations under the License.
13#
14# When distributing Covered Code, include this CDDL HEADER in each
15# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
16# If applicable, add the following below this CDDL HEADER, with the
17# fields enclosed by brackets "[]" replaced with your own identifying
18# information: Portions Copyright [yyyy] [name of copyright owner]
19#
20# CDDL HEADER END
21#
22
23#
24# Copyright (c) 1999, 2010, Oracle and/or its affiliates. All rights reserved.
25# Copyright 2008, 2010, Richard Lowe
26# Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
27# Copyright 2012 Joshua M. Clulow <josh@sysmgr.org>
28#
29# Based on the nightly script from the integration folks,
30# Mostly modified and owned by mike_s.
31# Changes also by kjc, dmk.
32#
33# BRINGOVER_WS may be specified in the env file.
34# The default is the old behavior of CLONE_WS
35#
36# -i on the command line, means fast options, so when it's on the
37# command line (only), lint and check builds are skipped no matter what
38# the setting of their individual flags are in NIGHTLY_OPTIONS.
39#
40# LINTDIRS can be set in the env file, format is a list of:
41#
42#	/dirname-to-run-lint-on flag
43#
44#	Where flag is:	y - enable lint noise diff output
45#			n - disable lint noise diff output
46#
47#	For example: LINTDIRS="$SRC/uts n $SRC/stand y $SRC/psm y"
48#
49# OPTHOME and TEAMWARE may be set in the environment to override /opt
50# and /opt/teamware defaults.
51#
52
53#
54# The CDPATH variable causes ksh's `cd' builtin to emit messages to stdout
55# under certain circumstances, which can really screw things up; unset it.
56#
57unset CDPATH
58
59# Get the absolute path of the nightly script that the user invoked.  This
60# may be a relative path, and we need to do this before changing directory.
61nightly_path=`whence $0`
62
63#
64# Keep track of where we found nightly so we can invoke the matching
65# which_scm script.  If that doesn't work, don't go guessing, just rely
66# on the $PATH settings, which will generally give us either /opt/onbld
67# or the user's workspace.
68#
69WHICH_SCM=$(dirname $nightly_path)/which_scm
70if [[ ! -x $WHICH_SCM ]]; then
71	WHICH_SCM=which_scm
72fi
73
74function fatal_error
75{
76	print -u2 "nightly: $*"
77	exit 1
78}
79
80#
81# Function to do a DEBUG and non-DEBUG build. Needed because we might
82# need to do another for the source build, and since we only deliver DEBUG or
83# non-DEBUG packages.
84#
85# usage: normal_build
86#
87function normal_build {
88
89	typeset orig_p_FLAG="$p_FLAG"
90	typeset crypto_signer="$CODESIGN_USER"
91
92	suffix=""
93
94	# non-DEBUG build begins
95
96	if [ "$F_FLAG" = "n" ]; then
97		set_non_debug_build_flags
98		CODESIGN_USER="$crypto_signer" \
99		    build "non-DEBUG" "$suffix-nd" "-nd" "$MULTI_PROTO"
100		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
101		    "$p_FLAG" = "y" ]; then
102			copy_ihv_pkgs non-DEBUG -nd
103		fi
104	else
105		echo "\n==== No non-DEBUG $open_only build ====\n" >> "$LOGFILE"
106	fi
107
108	# non-DEBUG build ends
109
110	# DEBUG build begins
111
112	if [ "$D_FLAG" = "y" ]; then
113		set_debug_build_flags
114		CODESIGN_USER="$crypto_signer" \
115		    build "DEBUG" "$suffix" "" "$MULTI_PROTO"
116		if [ "$build_ok" = "y" -a "$X_FLAG" = "y" -a \
117		    "$p_FLAG" = "y" ]; then
118			copy_ihv_pkgs DEBUG ""
119		fi
120	else
121		echo "\n==== No DEBUG $open_only build ====\n" >> "$LOGFILE"
122	fi
123
124	# DEBUG build ends
125
126	p_FLAG="$orig_p_FLAG"
127}
128
129#
130# usage: run_hook HOOKNAME ARGS...
131#
132# If variable "$HOOKNAME" is defined, insert a section header into
133# our logs and then run the command with ARGS
134#
135function run_hook {
136	HOOKNAME=$1
137    	eval HOOKCMD=\$$HOOKNAME
138	shift
139
140	if [ -n "$HOOKCMD" ]; then
141	    	(
142			echo "\n==== Running $HOOKNAME command: $HOOKCMD ====\n"
143		    	( $HOOKCMD "$@" 2>&1 )
144			if [ "$?" -ne 0 ]; then
145			    	# Let exit status propagate up
146			    	touch $TMPDIR/abort
147			fi
148		) | tee -a $mail_msg_file >> $LOGFILE
149
150		if [ -f $TMPDIR/abort ]; then
151			build_ok=n
152			echo "\nAborting at request of $HOOKNAME" |
153				tee -a $mail_msg_file >> $LOGFILE
154			exit 1
155		fi
156	fi
157}
158
159#
160# usage: filelist DESTDIR PATTERN
161#
162function filelist {
163	DEST=$1
164	PATTERN=$2
165	cd ${DEST}
166}
167
168# function to save off binaries after a full build for later
169# restoration
170function save_binaries {
171	# save off list of binaries
172	echo "\n==== Saving binaries from build at `date` ====\n" | \
173	    tee -a $mail_msg_file >> $LOGFILE
174	rm -f ${BINARCHIVE}
175	cd ${CODEMGR_WS}
176	filelist ${CODEMGR_WS} '^preserve:' >> $LOGFILE
177	filelist ${CODEMGR_WS} '^preserve:' | \
178	    cpio -ocB 2>/dev/null | compress \
179	    > ${BINARCHIVE}
180}
181
182# delete files
183# usage: hybridize_files DESTDIR MAKE_TARGET
184function hybridize_files {
185	DEST=$1
186	MAKETARG=$2
187
188	echo "\n==== Hybridizing files at `date` ====\n" | \
189	    tee -a $mail_msg_file >> $LOGFILE
190	for i in `filelist ${DEST} '^delete:'`
191	do
192		echo "removing ${i}." | tee -a $mail_msg_file >> $LOGFILE
193		rm -rf "${i}"
194	done
195	for i in `filelist ${DEST} '^hybridize:' `
196	do
197		echo "hybridizing ${i}." | tee -a $mail_msg_file >> $LOGFILE
198		rm -f ${i}+
199		sed -e "/^# HYBRID DELETE START/,/^# HYBRID DELETE END/d" \
200		    < ${i} > ${i}+
201		mv ${i}+ ${i}
202	done
203}
204
205# restore binaries into the proper source tree.
206# usage: restore_binaries DESTDIR MAKE_TARGET
207function restore_binaries {
208	DEST=$1
209	MAKETARG=$2
210
211	echo "\n==== Restoring binaries to ${MAKETARG} at `date` ====\n" | \
212	    tee -a $mail_msg_file >> $LOGFILE
213	cd ${DEST}
214	zcat ${BINARCHIVE} | \
215	    cpio -idmucvB 2>/dev/null | tee -a $mail_msg_file >> ${LOGFILE}
216}
217
218# rename files we save binaries of
219# usage: rename_files DESTDIR MAKE_TARGET
220function rename_files {
221	DEST=$1
222	MAKETARG=$2
223	echo "\n==== Renaming source files in ${MAKETARG} at `date` ====\n" | \
224	    tee -a $mail_msg_file >> $LOGFILE
225	for i in `filelist ${DEST} '^rename:'`
226	do
227		echo ${i} | tee -a $mail_msg_file >> ${LOGFILE}
228		rm -f ${i}.export
229		mv ${i} ${i}.export
230	done
231}
232
233# Return library search directive as function of given root.
234function myldlibs {
235	echo "-L$1/lib -L$1/usr/lib"
236}
237
238# Return header search directive as function of given root.
239function myheaders {
240	echo "-I$1/usr/include"
241}
242
243#
244# Function to do the build, including package generation.
245# usage: build LABEL SUFFIX ND MULTIPROTO
246# - LABEL is used to tag build output.
247# - SUFFIX is used to distinguish files (e.g., DEBUG vs non-DEBUG,
248#   open-only vs full tree).
249# - ND is "-nd" (non-DEBUG builds) or "" (DEBUG builds).
250# - If MULTIPROTO is "yes", it means to name the proto area according to
251#   SUFFIX.  Otherwise ("no"), (re)use the standard proto area.
252#
253function build {
254	LABEL=$1
255	SUFFIX=$2
256	ND=$3
257	MULTIPROTO=$4
258	INSTALLOG=install${SUFFIX}-${MACH}
259	NOISE=noise${SUFFIX}-${MACH}
260	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
261
262	ORIGROOT=$ROOT
263	[ $MULTIPROTO = no ] || export ROOT=$ROOT$SUFFIX
264
265	export ENVLDLIBS1=`myldlibs $ROOT`
266	export ENVCPPFLAGS1=`myheaders $ROOT`
267
268	this_build_ok=y
269	#
270	#	Build OS-Networking source
271	#
272	echo "\n==== Building OS-Net source at `date` ($LABEL) ====\n" \
273		>> $LOGFILE
274
275	rm -f $SRC/${INSTALLOG}.out
276	cd $SRC
277	/bin/time $MAKE -e install 2>&1 | \
278	    tee -a $SRC/${INSTALLOG}.out >> $LOGFILE
279
280	if [[ "$SCM_TYPE" = teamware ]]; then
281		echo "\n==== SCCS Noise ($LABEL) ====\n" >> $mail_msg_file
282		egrep 'sccs(check:| *get)' $SRC/${INSTALLOG}.out >> \
283			$mail_msg_file
284	fi
285
286	echo "\n==== Build errors ($LABEL) ====\n" >> $mail_msg_file
287	egrep ":" $SRC/${INSTALLOG}.out |
288		egrep -e "(^${MAKE}:|[ 	]error[: 	\n])" | \
289		egrep -v "Ignoring unknown host" | \
290		egrep -v "cc .* -o error " | \
291		egrep -v "warning" >> $mail_msg_file
292	if [ "$?" = "0" ]; then
293		build_ok=n
294		this_build_ok=n
295	fi
296	grep "bootblock image is .* bytes too big" $SRC/${INSTALLOG}.out \
297		>> $mail_msg_file
298	if [ "$?" = "0" ]; then
299		build_ok=n
300		this_build_ok=n
301	fi
302
303	if [ "$W_FLAG" = "n" ]; then
304		echo "\n==== Build warnings ($LABEL) ====\n" >>$mail_msg_file
305		egrep -i warning: $SRC/${INSTALLOG}.out \
306			| egrep -v '^tic:' \
307			| egrep -v "symbol (\`|')timezone' has differing types:" \
308		        | egrep -v "parameter <PSTAMP> set to" \
309			| egrep -v "Ignoring unknown host" \
310			| egrep -v "redefining segment flags attribute for" \
311			>> $mail_msg_file
312	fi
313
314	echo "\n==== Ended OS-Net source build at `date` ($LABEL) ====\n" \
315		>> $LOGFILE
316
317	echo "\n==== Elapsed build time ($LABEL) ====\n" >>$mail_msg_file
318	tail -3  $SRC/${INSTALLOG}.out >>$mail_msg_file
319
320	if [ "$i_FLAG" = "n" -a "$W_FLAG" = "n" ]; then
321		rm -f $SRC/${NOISE}.ref
322		if [ -f $SRC/${NOISE}.out ]; then
323			mv $SRC/${NOISE}.out $SRC/${NOISE}.ref
324		fi
325		grep : $SRC/${INSTALLOG}.out \
326			| egrep -v '^/' \
327			| egrep -v '^(Start|Finish|real|user|sys|./bld_awk)' \
328			| egrep -v '^tic:' \
329			| egrep -v '^mcs' \
330			| egrep -v '^LD_LIBRARY_PATH=' \
331			| egrep -v 'ar: creating' \
332			| egrep -v 'ar: writing' \
333			| egrep -v 'conflicts:' \
334			| egrep -v ':saved created' \
335			| egrep -v '^stty.*c:' \
336			| egrep -v '^mfgname.c:' \
337			| egrep -v '^uname-i.c:' \
338			| egrep -v '^volumes.c:' \
339			| egrep -v '^lint library construction:' \
340			| egrep -v 'tsort: INFORM:' \
341			| egrep -v 'stripalign:' \
342			| egrep -v 'chars, width' \
343			| egrep -v "symbol (\`|')timezone' has differing types:" \
344			| egrep -v 'PSTAMP' \
345			| egrep -v '|%WHOANDWHERE%|' \
346			| egrep -v '^Manifying' \
347			| egrep -v 'Ignoring unknown host' \
348			| egrep -v 'Processing method:' \
349			| egrep -v '^Writing' \
350			| egrep -v 'spellin1:' \
351			| egrep -v '^adding:' \
352			| egrep -v "^echo 'msgid" \
353			| egrep -v '^echo ' \
354			| egrep -v '\.c:$' \
355			| egrep -v '^Adding file:' \
356			| egrep -v 'CLASSPATH=' \
357			| egrep -v '\/var\/mail\/:saved' \
358			| egrep -v -- '-DUTS_VERSION=' \
359			| egrep -v '^Running Mkbootstrap' \
360			| egrep -v '^Applet length read:' \
361			| egrep -v 'bytes written:' \
362			| egrep -v '^File:SolarisAuthApplet.bin' \
363			| egrep -v -i 'jibversion' \
364			| egrep -v '^Output size:' \
365			| egrep -v '^Solo size statistics:' \
366			| egrep -v '^Using ROM API Version' \
367			| egrep -v '^Zero Signature length:' \
368			| egrep -v '^Note \(probably harmless\):' \
369			| egrep -v '::' \
370			| egrep -v -- '-xcache' \
371			| egrep -v '^\+' \
372			| egrep -v '^cc1: note: -fwritable-strings' \
373			| egrep -v 'svccfg-native -s svc:/' \
374			| sort | uniq >$SRC/${NOISE}.out
375		if [ ! -f $SRC/${NOISE}.ref ]; then
376			cp $SRC/${NOISE}.out $SRC/${NOISE}.ref
377		fi
378		echo "\n==== Build noise differences ($LABEL) ====\n" \
379			>>$mail_msg_file
380		diff $SRC/${NOISE}.ref $SRC/${NOISE}.out >>$mail_msg_file
381	fi
382
383	#
384	#	Re-sign selected binaries using signing server
385	#	(gatekeeper builds only)
386	#
387	if [ -n "$CODESIGN_USER" -a "$this_build_ok" = "y" ]; then
388		echo "\n==== Signing proto area at `date` ====\n" >> $LOGFILE
389		signing_file="${TMPDIR}/signing"
390		rm -f ${signing_file}
391		export CODESIGN_USER
392		signproto $SRC/tools/codesign/creds 2>&1 | \
393			tee -a ${signing_file} >> $LOGFILE
394		echo "\n==== Finished signing proto area at `date` ====\n" \
395		    >> $LOGFILE
396		echo "\n==== Crypto module signing errors ($LABEL) ====\n" \
397		    >> $mail_msg_file
398		egrep 'WARNING|ERROR' ${signing_file} >> $mail_msg_file
399		if (( $? == 0 )) ; then
400			build_ok=n
401			this_build_ok=n
402		fi
403	fi
404
405	#
406	#	Building Packages
407	#
408	if [ "$p_FLAG" = "y" -a "$this_build_ok" = "y" ]; then
409		if [ -d $SRC/pkg -o -d $SRC/pkgdefs ]; then
410			echo "\n==== Creating $LABEL packages at `date` ====\n" \
411				>> $LOGFILE
412			echo "Clearing out $PKGARCHIVE ..." >> $LOGFILE
413			rm -rf $PKGARCHIVE >> "$LOGFILE" 2>&1
414			mkdir -p $PKGARCHIVE >> "$LOGFILE" 2>&1
415
416			for d in pkg pkgdefs; do
417				if [ ! -f "$SRC/$d/Makefile" ]; then
418					continue
419				fi
420				rm -f $SRC/$d/${INSTALLOG}.out
421				cd $SRC/$d
422				/bin/time $MAKE -e install 2>&1 | \
423					tee -a $SRC/$d/${INSTALLOG}.out >> $LOGFILE
424			done
425
426			echo "\n==== package build errors ($LABEL) ====\n" \
427				>> $mail_msg_file
428
429			for d in pkg pkgdefs; do
430				if [ ! -f "$SRC/$d/Makefile" ]; then
431					continue
432				fi
433
434				egrep "${MAKE}|ERROR|WARNING" $SRC/$d/${INSTALLOG}.out | \
435					grep ':' | \
436					grep -v PSTAMP | \
437					egrep -v "Ignoring unknown host" \
438					>> $mail_msg_file
439			done
440		else
441			#
442			# Handle it gracefully if -p was set but there are
443			# neither pkg nor pkgdefs directories.
444			#
445			echo "\n==== No $LABEL packages to build ====\n" \
446				>> $LOGFILE
447		fi
448	else
449		echo "\n==== Not creating $LABEL packages ====\n" >> $LOGFILE
450	fi
451
452	ROOT=$ORIGROOT
453}
454
455# Usage: dolint /dir y|n
456# Arg. 2 is a flag to turn on/off the lint diff output
457function dolint {
458	if [ ! -d "$1" ]; then
459		echo "dolint error: $1 is not a directory"
460		exit 1
461	fi
462
463	if [ "$2" != "y" -a "$2" != "n" ]; then
464		echo "dolint internal error: $2 should be 'y' or 'n'"
465		exit 1
466	fi
467
468	lintdir=$1
469	dodiff=$2
470	base=`basename $lintdir`
471	LINTOUT=$lintdir/lint-${MACH}.out
472	LINTNOISE=$lintdir/lint-noise-${MACH}
473	export ENVLDLIBS1=`myldlibs $ROOT`
474	export ENVCPPFLAGS1=`myheaders $ROOT`
475
476	set_debug_build_flags
477
478	#
479	#	'$MAKE lint' in $lintdir
480	#
481	echo "\n==== Begin '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
482
483	# remove old lint.out
484	rm -f $lintdir/lint.out $lintdir/lint-noise.out
485	if [ -f $lintdir/lint-noise.ref ]; then
486		mv $lintdir/lint-noise.ref ${LINTNOISE}.ref
487	fi
488
489	rm -f $LINTOUT
490	cd $lintdir
491	#
492	# Remove all .ln files to ensure a full reference file
493	#
494	rm -f Nothing_to_remove \
495	    `find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \) \
496	    	-prune -o -type f -name '*.ln' -print `
497
498	/bin/time $MAKE -ek lint 2>&1 | \
499	    tee -a $LINTOUT >> $LOGFILE
500	echo "\n==== '$MAKE lint' of $base ERRORS ====\n" >> $mail_msg_file
501	grep "$MAKE:" $LINTOUT |
502		egrep -v "Ignoring unknown host" \
503		>> $mail_msg_file
504
505	echo "\n==== Ended '$MAKE lint' of $base at `date` ====\n" >> $LOGFILE
506
507	echo "\n==== Elapsed time of '$MAKE lint' of $base ====\n" \
508		>>$mail_msg_file
509	tail -3  $LINTOUT >>$mail_msg_file
510
511	rm -f ${LINTNOISE}.ref
512	if [ -f ${LINTNOISE}.out ]; then
513		mv ${LINTNOISE}.out ${LINTNOISE}.ref
514	fi
515        grep : $LINTOUT | \
516		egrep -v '^(real|user|sys)' |
517		egrep -v '(library construction)' | \
518		egrep -v ': global crosschecks' | \
519		egrep -v 'Ignoring unknown host' | \
520		egrep -v '\.c:$' | \
521		sort | uniq > ${LINTNOISE}.out
522	if [ ! -f ${LINTNOISE}.ref ]; then
523		cp ${LINTNOISE}.out ${LINTNOISE}.ref
524	fi
525	if [ "$dodiff" != "n" ]; then
526		echo "\n==== lint warnings $base ====\n" \
527			>>$mail_msg_file
528		# should be none, though there are a few that were filtered out
529		# above
530		egrep -i '(warning|lint):' ${LINTNOISE}.out \
531			| sort | uniq >> $mail_msg_file
532		echo "\n==== lint noise differences $base ====\n" \
533			>> $mail_msg_file
534		diff ${LINTNOISE}.ref ${LINTNOISE}.out \
535			>> $mail_msg_file
536	fi
537}
538
539# Install proto area from IHV build
540
541function copy_ihv_proto {
542
543	echo "\n==== Installing IHV proto area ====\n" \
544		>> $LOGFILE
545	if [ -d "$IA32_IHV_ROOT" ]; then
546		if [ ! -d "$ROOT" ]; then
547			echo "mkdir -p $ROOT" >> $LOGFILE
548			mkdir -p $ROOT
549		fi
550		echo "copying $IA32_IHV_ROOT to $ROOT\n" >> $LOGFILE
551		cd $IA32_IHV_ROOT
552		tar cf - . | (cd $ROOT; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
553	else
554		echo "$IA32_IHV_ROOT: not found" >> $LOGFILE
555	fi
556
557	if [ "$MULTI_PROTO" = yes ]; then
558		if [ ! -d "$ROOT-nd" ]; then
559			echo "mkdir -p $ROOT-nd" >> $LOGFILE
560			mkdir -p $ROOT-nd
561		fi
562		# If there's a non-DEBUG version of the IHV proto area,
563		# copy it, but copy something if there's not.
564		if [ -d "$IA32_IHV_ROOT-nd" ]; then
565			echo "copying $IA32_IHV_ROOT-nd to $ROOT-nd\n" >> $LOGFILE
566			cd $IA32_IHV_ROOT-nd
567		elif [ -d "$IA32_IHV_ROOT" ]; then
568			echo "copying $IA32_IHV_ROOT to $ROOT-nd\n" >> $LOGFILE
569			cd $IA32_IHV_ROOT
570		else
571			echo "$IA32_IHV_ROOT{-nd,}: not found" >> $LOGFILE
572			return
573		fi
574		tar cf - . | (cd $ROOT-nd; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
575	fi
576}
577
578# Install IHV packages in PKGARCHIVE
579# usage: copy_ihv_pkgs LABEL SUFFIX
580function copy_ihv_pkgs {
581	LABEL=$1
582	SUFFIX=$2
583	# always use non-DEBUG IHV packages
584	IA32_IHV_PKGS=${IA32_IHV_PKGS_ORIG}-nd
585	PKGARCHIVE=${PKGARCHIVE_ORIG}${SUFFIX}
586
587	echo "\n==== Installing IHV packages from $IA32_IHV_PKGS ($LABEL) ====\n" \
588		>> $LOGFILE
589	if [ -d "$IA32_IHV_PKGS" ]; then
590		cd $IA32_IHV_PKGS
591		tar cf - * | \
592		   (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
593	else
594		echo "$IA32_IHV_PKGS: not found" >> $LOGFILE
595	fi
596
597	echo "\n==== Installing IHV packages from $IA32_IHV_BINARY_PKGS ($LABEL) ====\n" \
598		>> $LOGFILE
599	if [ -d "$IA32_IHV_BINARY_PKGS" ]; then
600		cd $IA32_IHV_BINARY_PKGS
601		tar cf - * | \
602		    (cd $PKGARCHIVE; umask 0; tar xpf - ) 2>&1 >> $LOGFILE
603	else
604		echo "$IA32_IHV_BINARY_PKGS: not found" >> $LOGFILE
605	fi
606}
607
608#
609# Build and install the onbld tools.
610#
611# usage: build_tools DESTROOT
612#
613# returns non-zero status if the build was successful.
614#
615function build_tools {
616	DESTROOT=$1
617
618	INSTALLOG=install-${MACH}
619
620	echo "\n==== Building tools at `date` ====\n" \
621		>> $LOGFILE
622
623	rm -f ${TOOLS}/${INSTALLOG}.out
624	cd ${TOOLS}
625	/bin/time $MAKE TOOLS_PROTO=${DESTROOT} -e install 2>&1 | \
626	    tee -a ${TOOLS}/${INSTALLOG}.out >> $LOGFILE
627
628	echo "\n==== Tools build errors ====\n" >> $mail_msg_file
629
630	egrep ":" ${TOOLS}/${INSTALLOG}.out |
631		egrep -e "(${MAKE}:|[ 	]error[: 	\n])" | \
632		egrep -v "Ignoring unknown host" | \
633		egrep -v warning >> $mail_msg_file
634	return $?
635}
636
637#
638# Set up to use locally installed tools.
639#
640# usage: use_tools TOOLSROOT
641#
642function use_tools {
643	TOOLSROOT=$1
644
645	#
646	# If we're not building ON workspace, then the TOOLSROOT
647	# settings here are clearly ignored by the workspace
648	# makefiles, prepending nonexistent directories to PATH is
649	# harmless, and we clearly do not wish to override
650	# ONBLD_TOOLS.
651	#
652	# If we're building an ON workspace, then the prepended PATH
653	# elements should supercede the preexisting ONBLD_TOOLS paths,
654	# and we want to override ONBLD_TOOLS to catch the tools that
655	# don't have specific path env vars here.
656	#
657	# So the only conditional behavior is overriding ONBLD_TOOLS,
658	# and we check for "an ON workspace" by looking for
659	# ${TOOLSROOT}/opt/onbld.
660	#
661
662	STABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/stabs
663	export STABS
664	CTFSTABS=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfstabs
665	export CTFSTABS
666	GENOFFSETS=${TOOLSROOT}/opt/onbld/bin/genoffsets
667	export GENOFFSETS
668
669	CTFCONVERT=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfconvert
670	export CTFCONVERT
671	CTFMERGE=${TOOLSROOT}/opt/onbld/bin/${MACH}/ctfmerge
672	export CTFMERGE
673
674	CTFCVTPTBL=${TOOLSROOT}/opt/onbld/bin/ctfcvtptbl
675	export CTFCVTPTBL
676	CTFFINDMOD=${TOOLSROOT}/opt/onbld/bin/ctffindmod
677	export CTFFINDMOD
678
679	if [ "$VERIFY_ELFSIGN" = "y" ]; then
680		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/elfsigncmp
681	else
682		ELFSIGN=${TOOLSROOT}/opt/onbld/bin/${MACH}/elfsign
683	fi
684	export ELFSIGN
685
686	PATH="${TOOLSROOT}/opt/onbld/bin/${MACH}:${PATH}"
687	PATH="${TOOLSROOT}/opt/onbld/bin:${PATH}"
688	export PATH
689
690	if [ -d "${TOOLSROOT}/opt/onbld" ]; then
691		ONBLD_TOOLS=${TOOLSROOT}/opt/onbld
692		export ONBLD_TOOLS
693	fi
694
695	echo "\n==== New environment settings. ====\n" >> $LOGFILE
696	echo "STABS=${STABS}" >> $LOGFILE
697	echo "CTFSTABS=${CTFSTABS}" >> $LOGFILE
698	echo "CTFCONVERT=${CTFCONVERT}" >> $LOGFILE
699	echo "CTFMERGE=${CTFMERGE}" >> $LOGFILE
700	echo "CTFCVTPTBL=${CTFCVTPTBL}" >> $LOGFILE
701	echo "CTFFINDMOD=${CTFFINDMOD}" >> $LOGFILE
702	echo "ELFSIGN=${ELFSIGN}" >> $LOGFILE
703	echo "PATH=${PATH}" >> $LOGFILE
704	echo "ONBLD_TOOLS=${ONBLD_TOOLS}" >> $LOGFILE
705}
706
707function staffer {
708	if [ $ISUSER -ne 0 ]; then
709		"$@"
710	else
711		arg="\"$1\""
712		shift
713		for i
714		do
715			arg="$arg \"$i\""
716		done
717		eval su $STAFFER -c \'$arg\'
718	fi
719}
720
721#
722# Verify that the closed tree is present if it needs to be.
723#
724function check_closed_tree {
725	if [[ ! -d "$ON_CLOSED_BINS" ]]; then
726		echo "ON_CLOSED_BINS must point to the closed binaries tree."
727		build_ok=n
728		exit 1
729	fi
730}
731
732function obsolete_build {
733    	echo "WARNING: Obsolete $1 build requested; request will be ignored"
734}
735
736#
737# wrapper over wsdiff.
738# usage: do_wsdiff LABEL OLDPROTO NEWPROTO
739#
740function do_wsdiff {
741	label=$1
742	oldproto=$2
743	newproto=$3
744
745	wsdiff="wsdiff"
746	[ "$t_FLAG" = y ] && wsdiff="wsdiff -t"
747
748	echo "\n==== Getting object changes since last build at `date`" \
749	    "($label) ====\n" | tee -a $LOGFILE >> $mail_msg_file
750	$wsdiff -s -r ${TMPDIR}/wsdiff.results $oldproto $newproto 2>&1 | \
751		    tee -a $LOGFILE >> $mail_msg_file
752	echo "\n==== Object changes determined at `date` ($label) ====\n" | \
753	    tee -a $LOGFILE >> $mail_msg_file
754}
755
756#
757# Functions for setting build flags (DEBUG/non-DEBUG).  Keep them
758# together.
759#
760
761function set_non_debug_build_flags {
762	export RELEASE_BUILD ; RELEASE_BUILD=
763	unset EXTRA_OPTIONS
764	unset EXTRA_CFLAGS
765}
766
767function set_debug_build_flags {
768	unset RELEASE_BUILD
769	unset EXTRA_OPTIONS
770	unset EXTRA_CFLAGS
771}
772
773
774MACH=`uname -p`
775
776if [ "$OPTHOME" = "" ]; then
777	OPTHOME=/opt
778	export OPTHOME
779fi
780if [ "$TEAMWARE" = "" ]; then
781	TEAMWARE=$OPTHOME/teamware
782	export TEAMWARE
783fi
784
785USAGE='Usage: nightly [-in] [+t] [-V VERS ] <env_file>
786
787Where:
788	-i	Fast incremental options (no clobber, lint, check)
789	-n      Do not do a bringover
790	+t	Use the build tools in $ONBLD_TOOLS/bin
791	-V VERS set the build version string to VERS
792
793	<env_file>  file in Bourne shell syntax that sets and exports
794	variables that configure the operation of this script and many of
795	the scripts this one calls. If <env_file> does not exist,
796	it will be looked for in $OPTHOME/onbld/env.
797
798non-DEBUG is the default build type. Build options can be set in the
799NIGHTLY_OPTIONS variable in the <env_file> as follows:
800
801	-A	check for ABI differences in .so files
802	-C	check for cstyle/hdrchk errors
803	-D	do a build with DEBUG on
804	-F	do _not_ do a non-DEBUG build
805	-G	gate keeper default group of options (-au)
806	-I	integration engineer default group of options (-ampu)
807	-M	do not run pmodes (safe file permission checker)
808	-N	do not run protocmp
809	-R	default group of options for building a release (-mp)
810	-U	update proto area in the parent
811	-V VERS set the build version string to VERS
812	-X	copy x86 IHV proto area
813	-f	find unreferenced files
814	-i	do an incremental build (no "make clobber")
815	-l	do "make lint" in $LINTDIRS (default: $SRC y)
816	-m	send mail to $MAILTO at end of build
817	-n      do not do a bringover
818	-o	build using root privileges to set OWNER/GROUP (old style)
819	-p	create packages
820	-r	check ELF runtime attributes in the proto area
821	-t	build and use the tools in $SRC/tools (default setting)
822	+t	Use the build tools in $ONBLD_TOOLS/bin
823	-u	update proto_list_$MACH and friends in the parent workspace;
824		when used with -f, also build an unrefmaster.out in the parent
825	-w	report on differences between previous and current proto areas
826	-z	compress cpio archives with gzip
827	-W	Do not report warnings (freeware gate ONLY)
828'
829#
830#	A log file will be generated under the name $LOGFILE
831#	for partially completed build and log.`date '+%F'`
832#	in the same directory for fully completed builds.
833#
834
835# default values for low-level FLAGS; G I R are group FLAGS
836A_FLAG=n
837C_FLAG=n
838D_FLAG=n
839F_FLAG=n
840f_FLAG=n
841i_FLAG=n; i_CMD_LINE_FLAG=n
842l_FLAG=n
843M_FLAG=n
844m_FLAG=n
845N_FLAG=n
846n_FLAG=n
847o_FLAG=n
848P_FLAG=n
849p_FLAG=n
850r_FLAG=n
851T_FLAG=n
852t_FLAG=y
853U_FLAG=n
854u_FLAG=n
855V_FLAG=n
856W_FLAG=n
857w_FLAG=n
858X_FLAG=n
859#
860XMOD_OPT=
861#
862build_ok=y
863
864#
865# examine arguments
866#
867
868OPTIND=1
869while getopts +intV: FLAG
870do
871	case $FLAG in
872	  i )	i_FLAG=y; i_CMD_LINE_FLAG=y
873		;;
874	  n )	n_FLAG=y
875		;;
876	 +t )	t_FLAG=n
877		;;
878	  V )	V_FLAG=y
879		V_ARG="$OPTARG"
880		;;
881	 \? )	echo "$USAGE"
882		exit 1
883		;;
884	esac
885done
886
887# correct argument count after options
888shift `expr $OPTIND - 1`
889
890# test that the path to the environment-setting file was given
891if [ $# -ne 1 ]; then
892	echo "$USAGE"
893	exit 1
894fi
895
896# check if user is running nightly as root
897# ISUSER is set non-zero if an ordinary user runs nightly, or is zero
898# when root invokes nightly.
899/usr/bin/id | grep '^uid=0(' >/dev/null 2>&1
900ISUSER=$?;	export ISUSER
901
902#
903# force locale to C
904LC_COLLATE=C;	export LC_COLLATE
905LC_CTYPE=C;	export LC_CTYPE
906LC_MESSAGES=C;	export LC_MESSAGES
907LC_MONETARY=C;	export LC_MONETARY
908LC_NUMERIC=C;	export LC_NUMERIC
909LC_TIME=C;	export LC_TIME
910
911# clear environment variables we know to be bad for the build
912unset LD_OPTIONS
913unset LD_AUDIT		LD_AUDIT_32		LD_AUDIT_64
914unset LD_BIND_NOW	LD_BIND_NOW_32		LD_BIND_NOW_64
915unset LD_BREADTH	LD_BREADTH_32		LD_BREADTH_64
916unset LD_CONFIG		LD_CONFIG_32		LD_CONFIG_64
917unset LD_DEBUG		LD_DEBUG_32		LD_DEBUG_64
918unset LD_DEMANGLE	LD_DEMANGLE_32		LD_DEMANGLE_64
919unset LD_FLAGS		LD_FLAGS_32		LD_FLAGS_64
920unset LD_LIBRARY_PATH	LD_LIBRARY_PATH_32	LD_LIBRARY_PATH_64
921unset LD_LOADFLTR	LD_LOADFLTR_32		LD_LOADFLTR_64
922unset LD_NOAUDIT	LD_NOAUDIT_32		LD_NOAUDIT_64
923unset LD_NOAUXFLTR	LD_NOAUXFLTR_32		LD_NOAUXFLTR_64
924unset LD_NOCONFIG	LD_NOCONFIG_32		LD_NOCONFIG_64
925unset LD_NODIRCONFIG	LD_NODIRCONFIG_32	LD_NODIRCONFIG_64
926unset LD_NODIRECT	LD_NODIRECT_32		LD_NODIRECT_64
927unset LD_NOLAZYLOAD	LD_NOLAZYLOAD_32	LD_NOLAZYLOAD_64
928unset LD_NOOBJALTER	LD_NOOBJALTER_32	LD_NOOBJALTER_64
929unset LD_NOVERSION	LD_NOVERSION_32		LD_NOVERSION_64
930unset LD_ORIGIN		LD_ORIGIN_32		LD_ORIGIN_64
931unset LD_PRELOAD	LD_PRELOAD_32		LD_PRELOAD_64
932unset LD_PROFILE	LD_PROFILE_32		LD_PROFILE_64
933
934unset CONFIG
935unset GROUP
936unset OWNER
937unset REMOTE
938unset ENV
939unset ARCH
940unset CLASSPATH
941unset NAME
942
943#
944# To get ONBLD_TOOLS from the environment, it must come from the env file.
945# If it comes interactively, it is generally TOOLS_PROTO, which will be
946# clobbered before the compiler version checks, which will therefore fail.
947#
948unset ONBLD_TOOLS
949
950#
951#	Setup environmental variables
952#
953if [ -f /etc/nightly.conf ]; then
954	. /etc/nightly.conf
955fi
956
957if [ -f $1 ]; then
958	if [[ $1 = */* ]]; then
959		. $1
960	else
961		. ./$1
962	fi
963else
964	if [ -f $OPTHOME/onbld/env/$1 ]; then
965		. $OPTHOME/onbld/env/$1
966	else
967		echo "Cannot find env file as either $1 or $OPTHOME/onbld/env/$1"
968		exit 1
969	fi
970fi
971
972# contents of stdenv.sh inserted after next line:
973# STDENV_START
974# STDENV_END
975
976# Check if we have sufficient data to continue...
977[[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
978if  [[ "${NIGHTLY_OPTIONS}" == ~(F)n ]] ; then
979	# Check if the gate data are valid if we don't do a "bringover" below
980	[[ -d "${CODEMGR_WS}" ]] || \
981		fatal_error "Error: ${CODEMGR_WS} is not a directory."
982	[[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || \
983		fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
984fi
985
986#
987# place ourselves in a new task, respecting BUILD_PROJECT if set.
988#
989if [ -z "$BUILD_PROJECT" ]; then
990	/usr/bin/newtask -c $$
991else
992	/usr/bin/newtask -c $$ -p $BUILD_PROJECT
993fi
994
995ps -o taskid= -p $$ | read build_taskid
996ps -o project= -p $$ | read build_project
997
998#
999# See if NIGHTLY_OPTIONS is set
1000#
1001if [ "$NIGHTLY_OPTIONS" = "" ]; then
1002	NIGHTLY_OPTIONS="-aBm"
1003fi
1004
1005#
1006# If BRINGOVER_WS was not specified, let it default to CLONE_WS
1007#
1008if [ "$BRINGOVER_WS" = "" ]; then
1009	BRINGOVER_WS=$CLONE_WS
1010fi
1011
1012#
1013# If CLOSED_BRINGOVER_WS was not specified, let it default to CLOSED_CLONE_WS
1014#
1015if [ "$CLOSED_BRINGOVER_WS" = "" ]; then
1016	CLOSED_BRINGOVER_WS=$CLOSED_CLONE_WS
1017fi
1018
1019#
1020# If BRINGOVER_FILES was not specified, default to usr
1021#
1022if [ "$BRINGOVER_FILES" = "" ]; then
1023	BRINGOVER_FILES="usr"
1024fi
1025
1026check_closed_tree
1027
1028#
1029# Note: changes to the option letters here should also be applied to the
1030#	bldenv script.  `d' is listed for backward compatibility.
1031#
1032NIGHTLY_OPTIONS=-${NIGHTLY_OPTIONS#-}
1033OPTIND=1
1034while getopts +ABCDdFfGIilMmNnoPpRrTtUuWwXxz FLAG $NIGHTLY_OPTIONS
1035do
1036	case $FLAG in
1037	  A )	A_FLAG=y
1038		;;
1039	  B )	D_FLAG=y
1040		;; # old version of D
1041	  C )	C_FLAG=y
1042		;;
1043	  D )	D_FLAG=y
1044		;;
1045	  F )	F_FLAG=y
1046		;;
1047	  f )	f_FLAG=y
1048		;;
1049	  G )   u_FLAG=y
1050		;;
1051	  I )	m_FLAG=y
1052		p_FLAG=y
1053		u_FLAG=y
1054		;;
1055	  i )	i_FLAG=y
1056		;;
1057	  l )	l_FLAG=y
1058		;;
1059	  M )	M_FLAG=y
1060		;;
1061	  m )	m_FLAG=y
1062		;;
1063	  N )	N_FLAG=y
1064		;;
1065	  n )	n_FLAG=y
1066		;;
1067	  o )	o_FLAG=y
1068		;;
1069	  P )	P_FLAG=y
1070		;; # obsolete
1071	  p )	p_FLAG=y
1072		;;
1073	  R )	m_FLAG=y
1074		p_FLAG=y
1075		;;
1076	  r )	r_FLAG=y
1077		;;
1078	  T )	T_FLAG=y
1079		;; # obsolete
1080	 +t )	t_FLAG=n
1081		;;
1082	  U )   if [ -z "${PARENT_ROOT}" ]; then
1083			echo "PARENT_ROOT must be set if the U flag is" \
1084			    "present in NIGHTLY_OPTIONS."
1085			exit 1
1086		fi
1087		NIGHTLY_PARENT_ROOT=$PARENT_ROOT
1088		if [ -n "${PARENT_TOOLS_ROOT}" ]; then
1089			NIGHTLY_PARENT_TOOLS_ROOT=$PARENT_TOOLS_ROOT
1090		fi
1091		U_FLAG=y
1092		;;
1093	  u )	u_FLAG=y
1094		;;
1095	  W )	W_FLAG=y
1096		;;
1097
1098	  w )	w_FLAG=y
1099		;;
1100	  X )	# now that we no longer need realmode builds, just
1101		# copy IHV packages.  only meaningful on x86.
1102		if [ "$MACH" = "i386" ]; then
1103			X_FLAG=y
1104		fi
1105		;;
1106	  x )	XMOD_OPT="-x"
1107		;;
1108	 \? )	echo "$USAGE"
1109		exit 1
1110		;;
1111	esac
1112done
1113
1114if [ $ISUSER -ne 0 ]; then
1115	if [ "$o_FLAG" = "y" ]; then
1116		echo "Old-style build requires root permission."
1117		exit 1
1118	fi
1119
1120	# Set default value for STAFFER, if needed.
1121	if [ -z "$STAFFER" -o "$STAFFER" = "nobody" ]; then
1122		STAFFER=`/usr/xpg4/bin/id -un`
1123		export STAFFER
1124	fi
1125fi
1126
1127if [ -z "$MAILTO" -o "$MAILTO" = "nobody" ]; then
1128	MAILTO=$STAFFER
1129	export MAILTO
1130fi
1131
1132PATH="$OPTHOME/onbld/bin:$OPTHOME/onbld/bin/${MACH}:/usr/ccs/bin"
1133PATH="$PATH:$OPTHOME/SUNWspro/bin:$TEAMWARE/bin:/usr/bin:/usr/sbin:/usr/ucb"
1134PATH="$PATH:/usr/openwin/bin:/usr/sfw/bin:/opt/sfw/bin:."
1135export PATH
1136
1137# roots of source trees, both relative to $SRC and absolute.
1138relsrcdirs="."
1139abssrcdirs="$SRC"
1140
1141unset CH
1142if [ "$o_FLAG" = "y" ]; then
1143# root invoked old-style build -- make sure it works as it always has
1144# by exporting 'CH'.  The current Makefile.master doesn't use this, but
1145# the old ones still do.
1146	PROTOCMPTERSE="protocmp.terse"
1147	CH=
1148	export CH
1149else
1150	PROTOCMPTERSE="protocmp.terse -gu"
1151fi
1152POUND_SIGN="#"
1153# have we set RELEASE_DATE in our env file?
1154if [ -z "$RELEASE_DATE" ]; then
1155	RELEASE_DATE=$(LC_ALL=C date +"%B %Y")
1156fi
1157BUILD_DATE=$(LC_ALL=C date +%Y-%b-%d)
1158BASEWSDIR=$(basename $CODEMGR_WS)
1159DEV_CM="\"@(#)SunOS Internal Development: $LOGNAME $BUILD_DATE [$BASEWSDIR]\""
1160
1161# we export POUND_SIGN, RELEASE_DATE and DEV_CM to speed up the build process
1162# by avoiding repeated shell invocations to evaluate Makefile.master definitions.
1163# we export o_FLAG and X_FLAG for use by makebfu, and by usr/src/pkg/Makefile
1164export o_FLAG X_FLAG POUND_SIGN RELEASE_DATE DEV_CM
1165
1166maketype="distributed"
1167if [[ -z "$MAKE" ]]; then
1168	MAKE=dmake
1169elif [[ ! -x "$MAKE" ]]; then
1170	echo "\$MAKE is set to garbage in the environment"
1171	exit 1
1172fi
1173# get the dmake version string alone
1174DMAKE_VERSION=$( $MAKE -v )
1175DMAKE_VERSION=${DMAKE_VERSION#*: }
1176# focus in on just the dotted version number alone
1177DMAKE_MAJOR=$( echo $DMAKE_VERSION | \
1178	sed -e 's/.*\<\([^.]*\.[^   ]*\).*$/\1/' )
1179# extract the second (or final) integer
1180DMAKE_MINOR=${DMAKE_MAJOR#*.}
1181DMAKE_MINOR=${DMAKE_MINOR%%.*}
1182# extract the first integer
1183DMAKE_MAJOR=${DMAKE_MAJOR%%.*}
1184CHECK_DMAKE=${CHECK_DMAKE:-y}
1185# x86 was built on the 12th, sparc on the 13th.
1186if [ "$CHECK_DMAKE" = "y" -a \
1187     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/12" -a \
1188     "$DMAKE_VERSION" != "Sun Distributed Make 7.3 2003/03/13" -a \( \
1189     "$DMAKE_MAJOR" -lt 7 -o \
1190     "$DMAKE_MAJOR" -eq 7 -a "$DMAKE_MINOR" -lt 4 \) ]; then
1191	if [ -z "$DMAKE_VERSION" ]; then
1192		echo "$MAKE is missing."
1193		exit 1
1194	fi
1195	echo `whence $MAKE`" version is:"
1196	echo "  ${DMAKE_VERSION}"
1197	cat <<EOF
1198
1199This version may not be safe for use.  Either set TEAMWARE to a better
1200path or (if you really want to use this version of dmake anyway), add
1201the following to your environment to disable this check:
1202
1203  CHECK_DMAKE=n
1204EOF
1205	exit 1
1206fi
1207export PATH
1208export MAKE
1209
1210if [ "${SUNWSPRO}" != "" ]; then
1211	PATH="${SUNWSPRO}/bin:$PATH"
1212	export PATH
1213fi
1214
1215hostname=$(uname -n)
1216if [[ $DMAKE_MAX_JOBS != +([0-9]) || $DMAKE_MAX_JOBS -eq 0 ]]
1217then
1218	maxjobs=
1219	if [[ -f $HOME/.make.machines ]]
1220	then
1221		# Note: there is a hard tab and space character in the []s
1222		# below.
1223		egrep -i "^[ 	]*$hostname[ 	\.]" \
1224			$HOME/.make.machines | read host jobs
1225		maxjobs=${jobs##*=}
1226	fi
1227
1228	if [[ $maxjobs != +([0-9]) || $maxjobs -eq 0 ]]
1229	then
1230		# default
1231		maxjobs=4
1232	fi
1233
1234	export DMAKE_MAX_JOBS=$maxjobs
1235fi
1236
1237DMAKE_MODE=parallel;
1238export DMAKE_MODE
1239
1240if [ -z "${ROOT}" ]; then
1241	echo "ROOT must be set."
1242	exit 1
1243fi
1244
1245#
1246# if -V flag was given, reset VERSION to V_ARG
1247#
1248if [ "$V_FLAG" = "y" ]; then
1249	VERSION=$V_ARG
1250fi
1251
1252#
1253# Check for IHV root for copying ihv proto area
1254#
1255if [ "$X_FLAG" = "y" ]; then
1256        if [ "$IA32_IHV_ROOT" = "" ]; then
1257		echo "IA32_IHV_ROOT: must be set for copying ihv proto"
1258		args_ok=n
1259        fi
1260        if [ ! -d "$IA32_IHV_ROOT" ]; then
1261                echo "$IA32_IHV_ROOT: not found"
1262                args_ok=n
1263        fi
1264        if [ "$IA32_IHV_WS" = "" ]; then
1265		echo "IA32_IHV_WS: must be set for copying ihv proto"
1266		args_ok=n
1267        fi
1268        if [ ! -d "$IA32_IHV_WS" ]; then
1269                echo "$IA32_IHV_WS: not found"
1270                args_ok=n
1271        fi
1272fi
1273
1274TMPDIR="/tmp/nightly.tmpdir.$$"
1275export TMPDIR
1276rm -rf ${TMPDIR}
1277mkdir -p $TMPDIR || exit 1
1278chmod 777 $TMPDIR
1279
1280#
1281# Keep elfsign's use of pkcs11_softtoken from looking in the user home
1282# directory, which doesn't always work.   Needed until all build machines
1283# have the fix for 6271754
1284#
1285SOFTTOKEN_DIR=$TMPDIR
1286export SOFTTOKEN_DIR
1287
1288#
1289# Tools should only be built non-DEBUG.  Keep track of the tools proto
1290# area path relative to $TOOLS, because the latter changes in an
1291# export build.
1292#
1293# TOOLS_PROTO is included below for builds other than usr/src/tools
1294# that look for this location.  For usr/src/tools, this will be
1295# overridden on the $MAKE command line in build_tools().
1296#
1297TOOLS=${SRC}/tools
1298TOOLS_PROTO_REL=proto/root_${MACH}-nd
1299TOOLS_PROTO=${TOOLS}/${TOOLS_PROTO_REL};	export TOOLS_PROTO
1300
1301unset   CFLAGS LD_LIBRARY_PATH LDFLAGS
1302
1303# create directories that are automatically removed if the nightly script
1304# fails to start correctly
1305function newdir {
1306	dir=$1
1307	toadd=
1308	while [ ! -d $dir ]; do
1309		toadd="$dir $toadd"
1310		dir=`dirname $dir`
1311	done
1312	torm=
1313	newlist=
1314	for dir in $toadd; do
1315		if staffer mkdir $dir; then
1316			newlist="$ISUSER $dir $newlist"
1317			torm="$dir $torm"
1318		else
1319			[ -z "$torm" ] || staffer rmdir $torm
1320			return 1
1321		fi
1322	done
1323	newdirlist="$newlist $newdirlist"
1324	return 0
1325}
1326newdirlist=
1327
1328[ -d $CODEMGR_WS ] || newdir $CODEMGR_WS || exit 1
1329
1330# since this script assumes the build is from full source, it nullifies
1331# variables likely to have been set by a "ws" script; nullification
1332# confines the search space for headers and libraries to the proto area
1333# built from this immediate source.
1334ENVLDLIBS1=
1335ENVLDLIBS2=
1336ENVLDLIBS3=
1337ENVCPPFLAGS1=
1338ENVCPPFLAGS2=
1339ENVCPPFLAGS3=
1340ENVCPPFLAGS4=
1341PARENT_ROOT=
1342
1343export ENVLDLIBS3 ENVCPPFLAGS1 ENVCPPFLAGS2 ENVCPPFLAGS3 ENVCPPFLAGS4 \
1344	ENVLDLIBS1 ENVLDLIBS2 PARENT_ROOT
1345
1346PKGARCHIVE_ORIG=$PKGARCHIVE
1347IA32_IHV_PKGS_ORIG=$IA32_IHV_PKGS
1348
1349#
1350# Juggle the logs and optionally send mail on completion.
1351#
1352
1353function logshuffle {
1354    	LLOG="$ATLOG/log.`date '+%F.%H:%M'`"
1355	if [ -f $LLOG -o -d $LLOG ]; then
1356	    	LLOG=$LLOG.$$
1357	fi
1358	mkdir $LLOG
1359	export LLOG
1360
1361	if [ "$build_ok" = "y" ]; then
1362		mv $ATLOG/proto_list_${MACH} $LLOG
1363
1364		if [ -f $ATLOG/proto_list_tools_${MACH} ]; then
1365			mv $ATLOG/proto_list_tools_${MACH} $LLOG
1366	        fi
1367
1368		if [ -f $TMPDIR/wsdiff.results ]; then
1369		    	mv $TMPDIR/wsdiff.results $LLOG
1370		fi
1371
1372		if [ -f $TMPDIR/wsdiff-nd.results ]; then
1373			mv $TMPDIR/wsdiff-nd.results $LLOG
1374		fi
1375	fi
1376
1377	#
1378	# Now that we're about to send mail, it's time to check the noise
1379	# file.  In the event that an error occurs beyond this point, it will
1380	# be recorded in the nightly.log file, but nowhere else.  This would
1381	# include only errors that cause the copying of the noise log to fail
1382	# or the mail itself not to be sent.
1383	#
1384
1385	exec >>$LOGFILE 2>&1
1386	if [ -s $build_noise_file ]; then
1387	    	echo "\n==== Nightly build noise ====\n" |
1388		    tee -a $LOGFILE >>$mail_msg_file
1389		cat $build_noise_file >>$LOGFILE
1390		cat $build_noise_file >>$mail_msg_file
1391		echo | tee -a $LOGFILE >>$mail_msg_file
1392	fi
1393	rm -f $build_noise_file
1394
1395	case "$build_ok" in
1396		y)
1397			state=Completed
1398			;;
1399		i)
1400			state=Interrupted
1401			;;
1402		*)
1403	    		state=Failed
1404			;;
1405	esac
1406	NIGHTLY_STATUS=$state
1407	export NIGHTLY_STATUS
1408
1409	run_hook POST_NIGHTLY $state
1410	run_hook SYS_POST_NIGHTLY $state
1411
1412	#
1413	# mailx(1) sets From: based on the -r flag
1414	# if it is given.
1415	#
1416	mailx_r=
1417	if [[ -n "${MAILFROM}" ]]; then
1418		mailx_r="-r ${MAILFROM}"
1419	fi
1420
1421	cat $build_time_file $build_environ_file $mail_msg_file \
1422	    > ${LLOG}/mail_msg
1423	if [ "$m_FLAG" = "y" ]; then
1424	    	cat ${LLOG}/mail_msg | /usr/bin/mailx ${mailx_r} -s \
1425	"Nightly ${MACH} Build of `basename ${CODEMGR_WS}` ${state}." \
1426			${MAILTO}
1427	fi
1428
1429	if [ "$u_FLAG" = "y" -a "$build_ok" = "y" ]; then
1430	    	staffer cp ${LLOG}/mail_msg $PARENT_WS/usr/src/mail_msg-${MACH}
1431		staffer cp $LOGFILE $PARENT_WS/usr/src/nightly-${MACH}.log
1432	fi
1433
1434	mv $LOGFILE $LLOG
1435}
1436
1437#
1438#	Remove the locks and temporary files on any exit
1439#
1440function cleanup {
1441    	logshuffle
1442
1443	[ -z "$lockfile" ] || staffer rm -f $lockfile
1444	[ -z "$atloglockfile" ] || rm -f $atloglockfile
1445	[ -z "$ulockfile" ] || staffer rm -f $ulockfile
1446	[ -z "$Ulockfile" ] || rm -f $Ulockfile
1447
1448	set -- $newdirlist
1449	while [ $# -gt 0 ]; do
1450		ISUSER=$1 staffer rmdir $2
1451		shift; shift
1452	done
1453	rm -rf $TMPDIR
1454}
1455
1456function cleanup_signal {
1457    	build_ok=i
1458	# this will trigger cleanup(), above.
1459	exit 1
1460}
1461
1462trap cleanup 0
1463trap cleanup_signal 1 2 3 15
1464
1465#
1466# Generic lock file processing -- make sure that the lock file doesn't
1467# exist.  If it does, it should name the build host and PID.  If it
1468# doesn't, then make sure we can create it.  Clean up locks that are
1469# known to be stale (assumes host name is unique among build systems
1470# for the workspace).
1471#
1472function create_lock {
1473	lockf=$1
1474	lockvar=$2
1475
1476	ldir=`dirname $lockf`
1477	[ -d $ldir ] || newdir $ldir || exit 1
1478	eval $lockvar=$lockf
1479
1480	while ! staffer ln -s $hostname.$STAFFER.$$ $lockf 2> /dev/null; do
1481		basews=`basename $CODEMGR_WS`
1482		ls -l $lockf | nawk '{print $NF}' | IFS=. read host user pid
1483		if [ "$host" != "$hostname" ]; then
1484			echo "$MACH build of $basews apparently" \
1485			    "already started by $user on $host as $pid."
1486			exit 1
1487		elif kill -s 0 $pid 2>/dev/null; then
1488			echo "$MACH build of $basews already started" \
1489			    "by $user as $pid."
1490			exit 1
1491		else
1492			# stale lock; clear it out and try again
1493			rm -f $lockf
1494		fi
1495	done
1496}
1497
1498#
1499# Return the list of interesting proto areas, depending on the current
1500# options.
1501#
1502function allprotos {
1503	typeset roots="$ROOT"
1504
1505	if [[ "$F_FLAG" = n && "$MULTI_PROTO" = yes ]]; then
1506		roots="$roots $ROOT-nd"
1507	fi
1508
1509	echo $roots
1510}
1511
1512# Ensure no other instance of this script is running on this host.
1513# LOCKNAME can be set in <env_file>, and is by default, but is not
1514# required due to the use of $ATLOG below.
1515if [ -n "$LOCKNAME" ]; then
1516	create_lock /tmp/$LOCKNAME "lockfile"
1517fi
1518#
1519# Create from one, two, or three other locks:
1520#	$ATLOG/nightly.lock
1521#		- protects against multiple builds in same workspace
1522#	$PARENT_WS/usr/src/nightly.$MACH.lock
1523#		- protects against multiple 'u' copy-backs
1524#	$NIGHTLY_PARENT_ROOT/nightly.lock
1525#		- protects against multiple 'U' copy-backs
1526#
1527# Overriding ISUSER to 1 causes the lock to be created as root if the
1528# script is run as root.  The default is to create it as $STAFFER.
1529ISUSER=1 create_lock $ATLOG/nightly.lock "atloglockfile"
1530if [ "$u_FLAG" = "y" ]; then
1531	create_lock $PARENT_WS/usr/src/nightly.$MACH.lock "ulockfile"
1532fi
1533if [ "$U_FLAG" = "y" ]; then
1534	# NIGHTLY_PARENT_ROOT is written as root if script invoked as root.
1535	ISUSER=1 create_lock $NIGHTLY_PARENT_ROOT/nightly.lock "Ulockfile"
1536fi
1537
1538# Locks have been taken, so we're doing a build and we're committed to
1539# the directories we may have created so far.
1540newdirlist=
1541
1542#
1543# Create mail_msg_file
1544#
1545mail_msg_file="${TMPDIR}/mail_msg"
1546touch $mail_msg_file
1547build_time_file="${TMPDIR}/build_time"
1548build_environ_file="${TMPDIR}/build_environ"
1549touch $build_environ_file
1550#
1551#	Move old LOGFILE aside
1552#	ATLOG directory already made by 'create_lock' above
1553#
1554if [ -f $LOGFILE ]; then
1555	mv -f $LOGFILE ${LOGFILE}-
1556fi
1557#
1558#	Build OsNet source
1559#
1560START_DATE=`date`
1561SECONDS=0
1562echo "\n==== Nightly $maketype build started:   $START_DATE ====" \
1563    | tee -a $LOGFILE > $build_time_file
1564
1565echo "\nBuild project:  $build_project\nBuild taskid:   $build_taskid" | \
1566    tee -a $mail_msg_file >> $LOGFILE
1567
1568# make sure we log only to the nightly build file
1569build_noise_file="${TMPDIR}/build_noise"
1570exec </dev/null >$build_noise_file 2>&1
1571
1572run_hook SYS_PRE_NIGHTLY
1573run_hook PRE_NIGHTLY
1574
1575echo "\n==== list of environment variables ====\n" >> $LOGFILE
1576env >> $LOGFILE
1577
1578echo "\n==== Nightly argument issues ====\n" | tee -a $mail_msg_file >> $LOGFILE
1579
1580if [ "$P_FLAG" = "y" ]; then
1581	obsolete_build GPROF | tee -a $mail_msg_file >> $LOGFILE
1582fi
1583
1584if [ "$T_FLAG" = "y" ]; then
1585	obsolete_build TRACE | tee -a $mail_msg_file >> $LOGFILE
1586fi
1587
1588if [ "$N_FLAG" = "y" ]; then
1589	if [ "$p_FLAG" = "y" ]; then
1590		cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1591WARNING: the p option (create packages) is set, but so is the N option (do
1592         not run protocmp); this is dangerous; you should unset the N option
1593EOF
1594	else
1595		cat <<EOF | tee -a $mail_msg_file >> $LOGFILE
1596Warning: the N option (do not run protocmp) is set; it probably shouldn't be
1597EOF
1598	fi
1599	echo "" | tee -a $mail_msg_file >> $LOGFILE
1600fi
1601
1602if [ "$D_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
1603	#
1604	# In the past we just complained but went ahead with the lint
1605	# pass, even though the proto area was built non-DEBUG.  It's
1606	# unlikely that non-DEBUG headers will make a difference, but
1607	# rather than assuming it's a safe combination, force the user
1608	# to specify a DEBUG build.
1609	#
1610	echo "WARNING: DEBUG build not requested; disabling lint.\n" \
1611	    | tee -a $mail_msg_file >> $LOGFILE
1612	l_FLAG=n
1613fi
1614
1615if [ "$f_FLAG" = "y" ]; then
1616	if [ "$i_FLAG" = "y" ]; then
1617		echo "WARNING: the -f flag cannot be used during incremental" \
1618		    "builds; ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1619		f_FLAG=n
1620	fi
1621	if [ "${l_FLAG}${p_FLAG}" != "yy" ]; then
1622		echo "WARNING: the -f flag requires -l, and -p;" \
1623		    "ignoring -f\n" | tee -a $mail_msg_file >> $LOGFILE
1624		f_FLAG=n
1625	fi
1626fi
1627
1628if [ "$w_FLAG" = "y" -a ! -d $ROOT ]; then
1629	echo "WARNING: -w specified, but $ROOT does not exist;" \
1630	    "ignoring -w\n" | tee -a $mail_msg_file >> $LOGFILE
1631	w_FLAG=n
1632fi
1633
1634if [ "$t_FLAG" = "n" ]; then
1635	#
1636	# We're not doing a tools build, so make sure elfsign(1) is
1637	# new enough to safely sign non-crypto binaries.  We test
1638	# debugging output from elfsign to detect the old version.
1639	#
1640	newelfsigntest=`SUNW_CRYPTO_DEBUG=stderr /usr/bin/elfsign verify \
1641	    -e /usr/lib/security/pkcs11_softtoken.so.1 2>&1 \
1642	    | egrep algorithmOID`
1643	if [ -z "$newelfsigntest" ]; then
1644		echo "WARNING: /usr/bin/elfsign out of date;" \
1645		    "will only sign crypto modules\n" | \
1646		    tee -a $mail_msg_file >> $LOGFILE
1647		export ELFSIGN_OBJECT=true
1648	elif [ "$VERIFY_ELFSIGN" = "y" ]; then
1649		echo "WARNING: VERIFY_ELFSIGN=y requires" \
1650		    "the -t flag; ignoring VERIFY_ELFSIGN\n" | \
1651		    tee -a $mail_msg_file >> $LOGFILE
1652	fi
1653fi
1654
1655case $MULTI_PROTO in
1656yes|no)	;;
1657*)
1658	echo "WARNING: MULTI_PROTO is \"$MULTI_PROTO\"; " \
1659	    "should be \"yes\" or \"no\"." | tee -a $mail_msg_file >> $LOGFILE
1660	echo "Setting MULTI_PROTO to \"no\".\n" | \
1661	    tee -a $mail_msg_file >> $LOGFILE
1662	export MULTI_PROTO=no
1663	;;
1664esac
1665
1666echo "\n==== Build version ====\n" | tee -a $mail_msg_file >> $LOGFILE
1667echo $VERSION | tee -a $mail_msg_file >> $LOGFILE
1668
1669# Save the current proto area if we're comparing against the last build
1670if [ "$w_FLAG" = "y" -a -d "$ROOT" ]; then
1671    if [ -d "$ROOT.prev" ]; then
1672	rm -rf $ROOT.prev
1673    fi
1674    mv $ROOT $ROOT.prev
1675fi
1676
1677# Same for non-DEBUG proto area
1678if [ "$w_FLAG" = "y" -a "$MULTI_PROTO" = yes -a -d "$ROOT-nd" ]; then
1679	if [ -d "$ROOT-nd.prev" ]; then
1680		rm -rf $ROOT-nd.prev
1681	fi
1682	mv $ROOT-nd $ROOT-nd.prev
1683fi
1684
1685#
1686# Echo the SCM type of the parent workspace, this can't just be which_scm
1687# as that does not know how to identify various network repositories.
1688#
1689function parent_wstype {
1690	typeset scm_type junk
1691
1692	CODEMGR_WS="$BRINGOVER_WS" "$WHICH_SCM" 2>/dev/null \
1693	    | read scm_type junk
1694	if [[ -z "$scm_type" || "$scm_type" == unknown ]]; then
1695		# Probe BRINGOVER_WS to determine its type
1696		if [[ $BRINGOVER_WS == svn*://* ]]; then
1697			scm_type="subversion"
1698		elif [[ $BRINGOVER_WS == file://* ]] &&
1699		    egrep -s "This is a Subversion repository" \
1700		    ${BRINGOVER_WS#file://}/README.txt 2> /dev/null; then
1701			scm_type="subversion"
1702		elif [[ $BRINGOVER_WS == ssh://* ]]; then
1703			scm_type="mercurial"
1704		elif [[ $BRINGOVER_WS == http://* ]] && \
1705		    wget -q -O- --save-headers "$BRINGOVER_WS/?cmd=heads" | \
1706		    egrep -s "application/mercurial" 2> /dev/null; then
1707			scm_type="mercurial"
1708		elif svn info $BRINGOVER_WS > /dev/null 2>&1; then
1709			scm_type="subversion"
1710		else
1711			scm_type="none"
1712		fi
1713	fi
1714
1715	# fold both unsupported and unrecognized results into "none"
1716	case "$scm_type" in
1717	none|subversion|teamware|mercurial)
1718		;;
1719	*)	scm_type=none
1720		;;
1721	esac
1722
1723	echo $scm_type
1724}
1725
1726# Echo the SCM types of $CODEMGR_WS and $BRINGOVER_WS
1727function child_wstype {
1728	typeset scm_type junk
1729
1730	# Probe CODEMGR_WS to determine its type
1731	if [[ -d $CODEMGR_WS ]]; then
1732		$WHICH_SCM | read scm_type junk || exit 1
1733	fi
1734
1735	case "$scm_type" in
1736	none|subversion|git|teamware|mercurial)
1737		;;
1738	*)	scm_type=none
1739		;;
1740	esac
1741
1742	echo $scm_type
1743}
1744
1745SCM_TYPE=$(child_wstype)
1746
1747#
1748#	Decide whether to clobber
1749#
1750if [ "$i_FLAG" = "n" -a -d "$SRC" ]; then
1751	echo "\n==== Make clobber at `date` ====\n" >> $LOGFILE
1752
1753	cd $SRC
1754	# remove old clobber file
1755	rm -f $SRC/clobber.out
1756	rm -f $SRC/clobber-${MACH}.out
1757
1758	# Remove all .make.state* files, just in case we are restarting
1759	# the build after having interrupted a previous 'make clobber'.
1760	find . \( -name SCCS -o -name .hg -o -name .svn -o -name .git \
1761		-o -name 'interfaces.*' \) -prune \
1762		-o -name '.make.*' -print | xargs rm -f
1763
1764	$MAKE -ek clobber 2>&1 | tee -a $SRC/clobber-${MACH}.out >> $LOGFILE
1765	echo "\n==== Make clobber ERRORS ====\n" >> $mail_msg_file
1766	grep "$MAKE:" $SRC/clobber-${MACH}.out |
1767		egrep -v "Ignoring unknown host" \
1768		>> $mail_msg_file
1769
1770	if [[ "$t_FLAG" = "y" ]]; then
1771		echo "\n==== Make tools clobber at `date` ====\n" >> $LOGFILE
1772		cd ${TOOLS}
1773		rm -f ${TOOLS}/clobber-${MACH}.out
1774		$MAKE TOOLS_PROTO=$TOOLS_PROTO -ek clobber 2>&1 | \
1775			tee -a ${TOOLS}/clobber-${MACH}.out >> $LOGFILE
1776		echo "\n==== Make tools clobber ERRORS ====\n" \
1777			>> $mail_msg_file
1778		grep "$MAKE:" ${TOOLS}/clobber-${MACH}.out \
1779			>> $mail_msg_file
1780		rm -rf ${TOOLS_PROTO}
1781		mkdir -p ${TOOLS_PROTO}
1782	fi
1783
1784	typeset roots=$(allprotos)
1785	echo "\n\nClearing $roots" >> "$LOGFILE"
1786	rm -rf $roots
1787
1788	# Get back to a clean workspace as much as possible to catch
1789	# problems that only occur on fresh workspaces.
1790	# Remove all .make.state* files, libraries, and .o's that may
1791	# have been omitted from clobber.  A couple of libraries are
1792	# under source code control, so leave them alone.
1793	# We should probably blow away temporary directories too.
1794	cd $SRC
1795	find $relsrcdirs \( -name SCCS -o -name .hg -o -name .svn \
1796	    -o -name .git -o -name 'interfaces.*' \) -prune -o \
1797	    \( -name '.make.*' -o -name 'lib*.a' -o -name 'lib*.so*' -o \
1798	       -name '*.o' \) -print | \
1799	    grep -v 'tools/ctf/dwarf/.*/libdwarf' | xargs rm -f
1800else
1801	echo "\n==== No clobber at `date` ====\n" >> $LOGFILE
1802fi
1803
1804type bringover_teamware > /dev/null 2>&1 || function bringover_teamware {
1805	# sleep on the parent workspace's lock
1806	while egrep -s write $BRINGOVER_WS/Codemgr_wsdata/locks
1807	do
1808		sleep 120
1809	done
1810
1811	if [[ -z $BRINGOVER ]]; then
1812		BRINGOVER=$TEAMWARE/bin/bringover
1813	fi
1814
1815	staffer $BRINGOVER -c "nightly update" -p $BRINGOVER_WS \
1816	    -w $CODEMGR_WS $BRINGOVER_FILES < /dev/null 2>&1 ||
1817		touch $TMPDIR/bringover_failed
1818
1819        staffer bringovercheck $CODEMGR_WS >$TMPDIR/bringovercheck.out 2>&1
1820	if [ -s $TMPDIR/bringovercheck.out ]; then
1821		echo "\n==== POST-BRINGOVER CLEANUP NOISE ====\n"
1822		cat $TMPDIR/bringovercheck.out
1823	fi
1824}
1825
1826type bringover_mercurial > /dev/null 2>&1 || function bringover_mercurial {
1827	typeset -x PATH=$PATH
1828
1829	# If the repository doesn't exist yet, then we want to populate it.
1830	if [[ ! -d $CODEMGR_WS/.hg ]]; then
1831		staffer hg init $CODEMGR_WS
1832		staffer echo "[paths]" > $CODEMGR_WS/.hg/hgrc
1833		staffer echo "default=$BRINGOVER_WS" >> $CODEMGR_WS/.hg/hgrc
1834		touch $TMPDIR/new_repository
1835	fi
1836
1837	typeset -x HGMERGE="/bin/false"
1838
1839	#
1840	# If the user has changes, regardless of whether those changes are
1841	# committed, and regardless of whether those changes conflict, then
1842	# we'll attempt to merge them either implicitly (uncommitted) or
1843	# explicitly (committed).
1844	#
1845	# These are the messages we'll use to help clarify mercurial output
1846	# in those cases.
1847	#
1848	typeset mergefailmsg="\
1849***\n\
1850*** nightly was unable to automatically merge your changes.  You should\n\
1851*** redo the full merge manually, following the steps outlined by mercurial\n\
1852*** above, then restart nightly.\n\
1853***\n"
1854	typeset mergepassmsg="\
1855***\n\
1856*** nightly successfully merged your changes.  This means that your working\n\
1857*** directory has been updated, but those changes are not yet committed.\n\
1858*** After nightly completes, you should validate the results of the merge,\n\
1859*** then use hg commit manually.\n\
1860***\n"
1861
1862	#
1863	# For each repository in turn:
1864	#
1865	# 1. Do the pull.  If this fails, dump the output and bail out.
1866	#
1867	# 2. If the pull resulted in an extra head, do an explicit merge.
1868	#    If this fails, dump the output and bail out.
1869	#
1870	# Because we can't rely on Mercurial to exit with a failure code
1871	# when a merge fails (Mercurial issue #186), we must grep the
1872	# output of pull/merge to check for attempted and/or failed merges.
1873	#
1874	# 3. If a merge failed, set the message and fail the bringover.
1875	#
1876	# 4. Otherwise, if a merge succeeded, set the message
1877	#
1878	# 5. Dump the output, and any message from step 3 or 4.
1879	#
1880
1881	typeset HG_SOURCE=$BRINGOVER_WS
1882	if [ ! -f $TMPDIR/new_repository ]; then
1883		HG_SOURCE=$TMPDIR/open_bundle.hg
1884		staffer hg --cwd $CODEMGR_WS incoming --bundle $HG_SOURCE \
1885		    -v $BRINGOVER_WS > $TMPDIR/incoming_open.out
1886
1887		#
1888		# If there are no incoming changesets, then incoming will
1889		# fail, and there will be no bundle file.  Reset the source,
1890		# to allow the remaining logic to complete with no false
1891		# negatives.  (Unlike incoming, pull will return success
1892		# for the no-change case.)
1893		#
1894		if (( $? != 0 )); then
1895			HG_SOURCE=$BRINGOVER_WS
1896		fi
1897	fi
1898
1899	staffer hg --cwd $CODEMGR_WS pull -u $HG_SOURCE \
1900	    > $TMPDIR/pull_open.out 2>&1
1901	if (( $? != 0 )); then
1902		printf "%s: pull failed as follows:\n\n" "$CODEMGR_WS"
1903		cat $TMPDIR/pull_open.out
1904		if grep "^merging.*failed" $TMPDIR/pull_open.out > /dev/null 2>&1; then
1905			printf "$mergefailmsg"
1906		fi
1907		touch $TMPDIR/bringover_failed
1908		return
1909	fi
1910
1911	if grep "not updating" $TMPDIR/pull_open.out > /dev/null 2>&1; then
1912		staffer hg --cwd $CODEMGR_WS merge \
1913		    >> $TMPDIR/pull_open.out 2>&1
1914		if (( $? != 0 )); then
1915			printf "%s: merge failed as follows:\n\n" \
1916			    "$CODEMGR_WS"
1917			cat $TMPDIR/pull_open.out
1918			if grep "^merging.*failed" $TMPDIR/pull_open.out \
1919			    > /dev/null 2>&1; then
1920				printf "$mergefailmsg"
1921			fi
1922			touch $TMPDIR/bringover_failed
1923			return
1924		fi
1925	fi
1926
1927	printf "updated %s with the following results:\n" "$CODEMGR_WS"
1928	cat $TMPDIR/pull_open.out
1929	if grep "^merging" $TMPDIR/pull_open.out >/dev/null 2>&1; then
1930		printf "$mergepassmsg"
1931	fi
1932	printf "\n"
1933
1934	#
1935	# Per-changeset output is neither useful nor manageable for a
1936	# newly-created repository.
1937	#
1938	if [ -f $TMPDIR/new_repository ]; then
1939		return
1940	fi
1941
1942	printf "\nadded the following changesets to open repository:\n"
1943	cat $TMPDIR/incoming_open.out
1944
1945	#
1946	# The closed repository could have been newly created, even though
1947	# the open one previously existed...
1948	#
1949	if [ -f $TMPDIR/new_closed ]; then
1950		return
1951	fi
1952
1953	if [ -f $TMPDIR/incoming_closed.out ]; then
1954		printf "\nadded the following changesets to closed repository:\n"
1955		cat $TMPDIR/incoming_closed.out
1956	fi
1957}
1958
1959type bringover_subversion > /dev/null 2>&1 || function bringover_subversion {
1960	typeset -x PATH=$PATH
1961
1962	if [[ ! -d $CODEMGR_WS/.svn ]]; then
1963		staffer svn checkout $BRINGOVER_WS $CODEMGR_WS ||
1964			touch $TMPDIR/bringover_failed
1965	else
1966		typeset root
1967		root=$(staffer svn info $CODEMGR_WS |
1968			nawk '/^Repository Root:/ {print $NF}')
1969		if [[ $root != $BRINGOVER_WS ]]; then
1970			# We fail here because there's no way to update
1971			# from a named repo.
1972			cat <<-EOF
1973			\$BRINGOVER_WS doesn't match repository root:
1974			  \$BRINGOVER_WS:  $BRINGOVER_WS
1975			  Repository root: $root
1976			EOF
1977			touch $TMPDIR/bringover_failed
1978		else
1979			# If a conflict happens, svn still exits 0.
1980			staffer svn update $CODEMGR_WS | tee $TMPDIR/pull.out ||
1981				touch $TMPDIR/bringover_failed
1982			if grep "^C" $TMPDIR/pull.out > /dev/null 2>&1; then
1983				touch $TMPDIR/bringover_failed
1984			fi
1985		fi
1986	fi
1987}
1988
1989type bringover_none > /dev/null 2>&1 || function bringover_none {
1990	echo "Couldn't figure out what kind of SCM to use for $BRINGOVER_WS."
1991	touch $TMPDIR/bringover_failed
1992}
1993
1994#
1995#	Decide whether to bringover to the codemgr workspace
1996#
1997if [ "$n_FLAG" = "n" ]; then
1998	PARENT_SCM_TYPE=$(parent_wstype)
1999
2000	if [[ $SCM_TYPE != none && $SCM_TYPE != $PARENT_SCM_TYPE ]]; then
2001		echo "cannot bringover from $PARENT_SCM_TYPE to $SCM_TYPE, " \
2002		    "quitting at `date`." | tee -a $mail_msg_file >> $LOGFILE
2003		exit 1
2004	fi
2005
2006	run_hook PRE_BRINGOVER
2007
2008	echo "\n==== bringover to $CODEMGR_WS at `date` ====\n" >> $LOGFILE
2009	echo "\n==== BRINGOVER LOG ====\n" >> $mail_msg_file
2010
2011	eval "bringover_${PARENT_SCM_TYPE}" 2>&1 |
2012		tee -a $mail_msg_file >> $LOGFILE
2013
2014	if [ -f $TMPDIR/bringover_failed ]; then
2015		rm -f $TMPDIR/bringover_failed
2016		build_ok=n
2017		echo "trouble with bringover, quitting at `date`." |
2018			tee -a $mail_msg_file >> $LOGFILE
2019		exit 1
2020	fi
2021
2022	#
2023	# It's possible that we used the bringover above to create
2024	# $CODEMGR_WS.  If so, then SCM_TYPE was previously "none,"
2025	# but should now be the same as $BRINGOVER_WS.
2026	#
2027	[[ $SCM_TYPE = none ]] && SCM_TYPE=$PARENT_SCM_TYPE
2028
2029	run_hook POST_BRINGOVER
2030
2031	check_closed_tree
2032
2033else
2034	echo "\n==== No bringover to $CODEMGR_WS ====\n" >> $LOGFILE
2035fi
2036
2037# Safeguards
2038[[ -v CODEMGR_WS ]] || fatal_error "Error: Variable CODEMGR_WS not set."
2039[[ -d "${CODEMGR_WS}" ]] || fatal_error "Error: ${CODEMGR_WS} is not a directory."
2040[[ -f "${CODEMGR_WS}/usr/src/Makefile" ]] || fatal_error "Error: ${CODEMGR_WS}/usr/src/Makefile not found."
2041
2042echo "\n==== Build environment ====\n" | tee -a $build_environ_file >> $LOGFILE
2043
2044# System
2045whence uname | tee -a $build_environ_file >> $LOGFILE
2046uname -a 2>&1 | tee -a $build_environ_file >> $LOGFILE
2047echo | tee -a $build_environ_file >> $LOGFILE
2048
2049# make
2050whence $MAKE | tee -a $build_environ_file >> $LOGFILE
2051$MAKE -v | tee -a $build_environ_file >> $LOGFILE
2052echo "number of concurrent jobs = $DMAKE_MAX_JOBS" |
2053    tee -a $build_environ_file >> $LOGFILE
2054
2055#
2056# Report the compiler versions.
2057#
2058
2059if [[ ! -f $SRC/Makefile ]]; then
2060	build_ok=n
2061	echo "\nUnable to find \"Makefile\" in $SRC." | \
2062	    tee -a $build_environ_file >> $LOGFILE
2063	exit 1
2064fi
2065
2066( cd $SRC
2067  for target in cc-version cc64-version java-version; do
2068	echo
2069	#
2070	# Put statefile somewhere we know we can write to rather than trip
2071	# over a read-only $srcroot.
2072	#
2073	rm -f $TMPDIR/make-state
2074	export SRC
2075	if $MAKE -K $TMPDIR/make-state -e $target 2>/dev/null; then
2076		continue
2077	fi
2078	touch $TMPDIR/nocompiler
2079  done
2080  echo
2081) | tee -a $build_environ_file >> $LOGFILE
2082
2083if [ -f $TMPDIR/nocompiler ]; then
2084	rm -f $TMPDIR/nocompiler
2085	build_ok=n
2086	echo "Aborting due to missing compiler." |
2087		tee -a $build_environ_file >> $LOGFILE
2088	exit 1
2089fi
2090
2091# as
2092whence as | tee -a $build_environ_file >> $LOGFILE
2093as -V 2>&1 | head -1 | tee -a $build_environ_file >> $LOGFILE
2094echo | tee -a $build_environ_file >> $LOGFILE
2095
2096# Check that we're running a capable link-editor
2097whence ld | tee -a $build_environ_file >> $LOGFILE
2098LDVER=`ld -V 2>&1`
2099echo $LDVER | tee -a $build_environ_file >> $LOGFILE
2100LDVER=`echo $LDVER | sed -e "s/.*-1\.\([0-9]*\).*/\1/"`
2101if [ `expr $LDVER \< 422` -eq 1 ]; then
2102	echo "The link-editor needs to be at version 422 or higher to build" | \
2103	    tee -a $build_environ_file >> $LOGFILE
2104	echo "the latest stuff.  Hope your build works." | \
2105	    tee -a $build_environ_file >> $LOGFILE
2106fi
2107
2108#
2109# Build and use the workspace's tools if requested
2110#
2111if [[ "$t_FLAG" = "y" ]]; then
2112	set_non_debug_build_flags
2113
2114	build_tools ${TOOLS_PROTO}
2115	if [[ $? != 0  && "$t_FLAG" = y ]]; then
2116		use_tools $TOOLS_PROTO
2117	fi
2118fi
2119
2120#
2121# copy ihv proto area in addition to the build itself
2122#
2123if [ "$X_FLAG" = "y" ]; then
2124	copy_ihv_proto
2125fi
2126
2127# timestamp the start of the normal build; the findunref tool uses it.
2128touch $SRC/.build.tstamp
2129
2130normal_build
2131
2132ORIG_SRC=$SRC
2133BINARCHIVE=${CODEMGR_WS}/bin-${MACH}.cpio.Z
2134
2135#
2136# There are several checks that need to look at the proto area, but
2137# they only need to look at one, and they don't care whether it's
2138# DEBUG or non-DEBUG.
2139#
2140if [[ "$MULTI_PROTO" = yes && "$D_FLAG" = n ]]; then
2141	checkroot=$ROOT-nd
2142else
2143	checkroot=$ROOT
2144fi
2145
2146if [ "$build_ok" = "y" ]; then
2147	echo "\n==== Creating protolist system file at `date` ====" \
2148		>> $LOGFILE
2149	protolist $checkroot > $ATLOG/proto_list_${MACH}
2150	echo "==== protolist system file created at `date` ====\n" \
2151		>> $LOGFILE
2152
2153	if [ "$N_FLAG" != "y" ]; then
2154
2155		E1=
2156		f1=
2157		if [ -d "$SRC/pkgdefs" ]; then
2158			f1="$SRC/pkgdefs/etc/exception_list_$MACH"
2159			if [ "$X_FLAG" = "y" ]; then
2160				f1="$f1 $IA32_IHV_WS/usr/src/pkgdefs/etc/exception_list_$MACH"
2161			fi
2162		fi
2163
2164		for f in $f1; do
2165			if [ -f "$f" ]; then
2166				E1="$E1 -e $f"
2167			fi
2168		done
2169
2170		E2=
2171		f2=
2172		if [ -d "$SRC/pkg" ]; then
2173			f2="$f2 exceptions/packaging"
2174		fi
2175
2176		for f in $f2; do
2177			if [ -f "$f" ]; then
2178				E2="$E2 -e $f"
2179			fi
2180		done
2181
2182		if [ -f "$REF_PROTO_LIST" ]; then
2183			#
2184			# For builds that copy the IHV proto area (-X), add the
2185			# IHV proto list to the reference list if the reference
2186			# was built without -X.
2187			#
2188			# For builds that don't copy the IHV proto area, add the
2189			# IHV proto list to the build's proto list if the
2190			# reference was built with -X.
2191			#
2192			# Use the presence of the first file entry of the cached
2193			# IHV proto list in the reference list to determine
2194			# whether it was built with -X or not.
2195			#
2196			IHV_REF_PROTO_LIST=$SRC/pkg/proto_list_ihv_$MACH
2197			grepfor=$(nawk '$1 == "f" { print $2; exit }' \
2198				$IHV_REF_PROTO_LIST 2> /dev/null)
2199			if [ $? = 0 -a -n "$grepfor" ]; then
2200				if [ "$X_FLAG" = "y" ]; then
2201					grep -w "$grepfor" \
2202						$REF_PROTO_LIST > /dev/null
2203					if [ ! "$?" = "0" ]; then
2204						REF_IHV_PROTO="-d $IHV_REF_PROTO_LIST"
2205					fi
2206				else
2207					grep -w "$grepfor" \
2208						$REF_PROTO_LIST > /dev/null
2209					if [ "$?" = "0" ]; then
2210						IHV_PROTO_LIST="$IHV_REF_PROTO_LIST"
2211					fi
2212				fi
2213			fi
2214		fi
2215	fi
2216
2217	if [ "$N_FLAG" != "y" -a -f $SRC/pkgdefs/Makefile ]; then
2218		echo "\n==== Impact on SVr4 packages ====\n" >> $mail_msg_file
2219		#
2220		# Compare the build's proto list with current package
2221		# definitions to audit the quality of package
2222		# definitions and makefile install targets. Use the
2223		# current exception list.
2224		#
2225		PKGDEFS_LIST=""
2226		for d in $abssrcdirs; do
2227			if [ -d $d/pkgdefs ]; then
2228				PKGDEFS_LIST="$PKGDEFS_LIST -d $d/pkgdefs"
2229			fi
2230		done
2231		if [ "$X_FLAG" = "y" -a \
2232		    -d $IA32_IHV_WS/usr/src/pkgdefs ]; then
2233			PKGDEFS_LIST="$PKGDEFS_LIST -d $IA32_IHV_WS/usr/src/pkgdefs"
2234		fi
2235		$PROTOCMPTERSE \
2236		    "Files missing from the proto area:" \
2237		    "Files missing from packages:" \
2238		    "Inconsistencies between pkgdefs and proto area:" \
2239		    ${E1} \
2240		    ${PKGDEFS_LIST} \
2241		    $ATLOG/proto_list_${MACH} \
2242		    >> $mail_msg_file
2243	fi
2244
2245	if [ "$N_FLAG" != "y" -a -d $SRC/pkg ]; then
2246		echo "\n==== Validating manifests against proto area ====\n" \
2247		    >> $mail_msg_file
2248		( cd $SRC/pkg ; $MAKE -e protocmp ROOT="$checkroot" ) \
2249		    >> $mail_msg_file
2250
2251	fi
2252
2253	if [ "$N_FLAG" != "y" -a -f "$REF_PROTO_LIST" ]; then
2254		echo "\n==== Impact on proto area ====\n" >> $mail_msg_file
2255		if [ -n "$E2" ]; then
2256			ELIST=$E2
2257		else
2258			ELIST=$E1
2259		fi
2260		$PROTOCMPTERSE \
2261			"Files in yesterday's proto area, but not today's:" \
2262			"Files in today's proto area, but not yesterday's:" \
2263			"Files that changed between yesterday and today:" \
2264			${ELIST} \
2265			-d $REF_PROTO_LIST \
2266			$REF_IHV_PROTO \
2267			$ATLOG/proto_list_${MACH} \
2268			$IHV_PROTO_LIST \
2269			>> $mail_msg_file
2270	fi
2271fi
2272
2273if [ "$u_FLAG" = "y"  -a "$build_ok" = "y" ]; then
2274	staffer cp $ATLOG/proto_list_${MACH} \
2275		$PARENT_WS/usr/src/proto_list_${MACH}
2276fi
2277
2278# Update parent proto area if necessary. This is done now
2279# so that the proto area has either DEBUG or non-DEBUG kernels.
2280# Note that this clears out the lock file, so we can dispense with
2281# the variable now.
2282if [ "$U_FLAG" = "y" -a "$build_ok" = "y" ]; then
2283	echo "\n==== Copying proto area to $NIGHTLY_PARENT_ROOT ====\n" | \
2284	    tee -a $LOGFILE >> $mail_msg_file
2285	rm -rf $NIGHTLY_PARENT_ROOT/*
2286	unset Ulockfile
2287	mkdir -p $NIGHTLY_PARENT_ROOT
2288	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2289		( cd $ROOT; tar cf - . |
2290		    ( cd $NIGHTLY_PARENT_ROOT;  umask 0; tar xpf - ) ) 2>&1 |
2291		    tee -a $mail_msg_file >> $LOGFILE
2292	fi
2293	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2294		rm -rf $NIGHTLY_PARENT_ROOT-nd/*
2295		mkdir -p $NIGHTLY_PARENT_ROOT-nd
2296		cd $ROOT-nd
2297		( tar cf - . |
2298		    ( cd $NIGHTLY_PARENT_ROOT-nd; umask 0; tar xpf - ) ) 2>&1 |
2299		    tee -a $mail_msg_file >> $LOGFILE
2300	fi
2301	if [ -n "${NIGHTLY_PARENT_TOOLS_ROOT}" ]; then
2302		echo "\n==== Copying tools proto area to $NIGHTLY_PARENT_TOOLS_ROOT ====\n" | \
2303		    tee -a $LOGFILE >> $mail_msg_file
2304		rm -rf $NIGHTLY_PARENT_TOOLS_ROOT/*
2305		mkdir -p $NIGHTLY_PARENT_TOOLS_ROOT
2306		if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2307			( cd $TOOLS_PROTO; tar cf - . |
2308			    ( cd $NIGHTLY_PARENT_TOOLS_ROOT;
2309			    umask 0; tar xpf - ) ) 2>&1 |
2310			    tee -a $mail_msg_file >> $LOGFILE
2311		fi
2312	fi
2313fi
2314
2315#
2316# ELF verification: ABI (-A) and runtime (-r) checks
2317#
2318if [[ ($build_ok = y) && ( ($A_FLAG = y) || ($r_FLAG = y) ) ]]; then
2319	# Directory ELF-data.$MACH holds the files produced by these tests.
2320	elf_ddir=$SRC/ELF-data.$MACH
2321
2322	# If there is a previous ELF-data backup directory, remove it. Then,
2323	# rotate current ELF-data directory into its place and create a new
2324	# empty directory
2325	rm -rf $elf_ddir.ref
2326	if [[ -d $elf_ddir ]]; then
2327		mv $elf_ddir $elf_ddir.ref
2328	fi
2329	mkdir -p $elf_ddir
2330
2331	# Call find_elf to produce a list of the ELF objects in the proto area.
2332	# This list is passed to check_rtime and interface_check, preventing
2333	# them from separately calling find_elf to do the same work twice.
2334	find_elf -fr $checkroot > $elf_ddir/object_list
2335
2336	if [[ $A_FLAG = y ]]; then
2337	       	echo "\n==== Check versioning and ABI information ====\n"  | \
2338		    tee -a $LOGFILE >> $mail_msg_file
2339
2340		# Produce interface description for the proto. Report errors.
2341		interface_check -o -w $elf_ddir -f object_list \
2342			-i interface -E interface.err
2343		if [[ -s $elf_ddir/interface.err ]]; then
2344			tee -a $LOGFILE < $elf_ddir/interface.err \
2345				>> $mail_msg_file
2346		fi
2347
2348		# If ELF_DATA_BASELINE_DIR is defined, compare the new interface
2349		# description file to that from the baseline gate. Issue a
2350		# warning if the baseline is not present, and keep going.
2351		if [[ "$ELF_DATA_BASELINE_DIR" != '' ]]; then
2352			base_ifile="$ELF_DATA_BASELINE_DIR/interface"
2353
2354		       	echo "\n==== Compare versioning and ABI information" \
2355			    "to baseline ====\n"  | \
2356			    tee -a $LOGFILE >> $mail_msg_file
2357		       	echo "Baseline:  $base_ifile\n" >> $LOGFILE
2358
2359			if [[ -f $base_ifile ]]; then
2360				interface_cmp -d -o $base_ifile \
2361				    $elf_ddir/interface > $elf_ddir/interface.cmp
2362				if [[ -s $elf_ddir/interface.cmp ]]; then
2363					echo | tee -a $LOGFILE >> $mail_msg_file
2364					tee -a $LOGFILE < \
2365					    $elf_ddir/interface.cmp \
2366					    >> $mail_msg_file
2367				fi
2368			else
2369			       	echo "baseline not available. comparison" \
2370                                    "skipped" | \
2371				    tee -a $LOGFILE >> $mail_msg_file
2372			fi
2373
2374		fi
2375	fi
2376
2377	if [[ $r_FLAG = y ]]; then
2378		echo "\n==== Check ELF runtime attributes ====\n" | \
2379		    tee -a $LOGFILE >> $mail_msg_file
2380
2381		# If we're doing a DEBUG build the proto area will be left
2382		# with debuggable objects, thus don't assert -s.
2383		if [[ $D_FLAG = y ]]; then
2384			rtime_sflag=""
2385		else
2386			rtime_sflag="-s"
2387		fi
2388		check_rtime -i -m -v $rtime_sflag -o -w $elf_ddir \
2389			-D object_list  -f object_list -E runtime.err \
2390			-I runtime.attr.raw
2391
2392		# check_rtime -I output needs to be sorted in order to
2393		# compare it to that from previous builds.
2394		sort $elf_ddir/runtime.attr.raw > $elf_ddir/runtime.attr
2395		rm $elf_ddir/runtime.attr.raw
2396
2397		# Report errors
2398		if [[ -s $elf_ddir/runtime.err ]]; then
2399			tee -a $LOGFILE < $elf_ddir/runtime.err \
2400				>> $mail_msg_file
2401		fi
2402
2403		# If there is an ELF-data directory from a previous build,
2404		# then diff the attr files. These files contain information
2405		# about dependencies, versioning, and runpaths. There is some
2406		# overlap with the ABI checking done above, but this also
2407		# flushes out non-ABI interface differences along with the
2408		# other information.
2409		echo "\n==== Diff ELF runtime attributes" \
2410		    "(since last build) ====\n" | \
2411		    tee -a $LOGFILE >> $mail_msg_file >> $mail_msg_file
2412
2413		if [[ -f $elf_ddir.ref/runtime.attr ]]; then
2414			diff $elf_ddir.ref/runtime.attr \
2415				$elf_ddir/runtime.attr \
2416				>> $mail_msg_file
2417		fi
2418	fi
2419
2420	# If -u set, copy contents of ELF-data.$MACH to the parent workspace.
2421	if [[ "$u_FLAG" = "y" ]]; then
2422		p_elf_ddir=$PARENT_WS/usr/src/ELF-data.$MACH
2423
2424		# If parent lacks the ELF-data.$MACH directory, create it
2425		if [[ ! -d $p_elf_ddir ]]; then
2426			staffer mkdir -p $p_elf_ddir
2427		fi
2428
2429		# These files are used asynchronously by other builds for ABI
2430		# verification, as above for the -A option. As such, we require
2431		# the file replacement to be atomic. Copy the data to a temp
2432		# file in the same filesystem and then rename into place.
2433		(
2434			cd $elf_ddir
2435			for elf_dfile in *; do
2436				staffer cp $elf_dfile \
2437				    ${p_elf_ddir}/${elf_dfile}.new
2438				staffer mv -f ${p_elf_ddir}/${elf_dfile}.new \
2439				    ${p_elf_ddir}/${elf_dfile}
2440			done
2441		)
2442	fi
2443fi
2444
2445# DEBUG lint of kernel begins
2446
2447if [ "$i_CMD_LINE_FLAG" = "n" -a "$l_FLAG" = "y" ]; then
2448	if [ "$LINTDIRS" = "" ]; then
2449		# LINTDIRS="$SRC/uts y $SRC/stand y $SRC/psm y"
2450		LINTDIRS="$SRC y"
2451	fi
2452	set $LINTDIRS
2453	while [ $# -gt 0 ]; do
2454		dolint $1 $2; shift; shift
2455	done
2456else
2457	echo "\n==== No '$MAKE lint' ====\n" >> $LOGFILE
2458fi
2459
2460# "make check" begins
2461
2462if [ "$i_CMD_LINE_FLAG" = "n" -a "$C_FLAG" = "y" ]; then
2463	# remove old check.out
2464	rm -f $SRC/check.out
2465
2466	rm -f $SRC/check-${MACH}.out
2467	cd $SRC
2468	$MAKE -ek check ROOT="$checkroot" 2>&1 | tee -a $SRC/check-${MACH}.out \
2469	    >> $LOGFILE
2470	echo "\n==== cstyle/hdrchk errors ====\n" >> $mail_msg_file
2471
2472	grep ":" $SRC/check-${MACH}.out |
2473		egrep -v "Ignoring unknown host" | \
2474		sort | uniq >> $mail_msg_file
2475else
2476	echo "\n==== No '$MAKE check' ====\n" >> $LOGFILE
2477fi
2478
2479echo "\n==== Find core files ====\n" | \
2480    tee -a $LOGFILE >> $mail_msg_file
2481
2482find $abssrcdirs -name core -a -type f -exec file {} \; | \
2483	tee -a $LOGFILE >> $mail_msg_file
2484
2485if [ "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2486	echo "\n==== Diff unreferenced files (since last build) ====\n" \
2487	    | tee -a $LOGFILE >>$mail_msg_file
2488	rm -f $SRC/unref-${MACH}.ref
2489	if [ -f $SRC/unref-${MACH}.out ]; then
2490		mv $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2491	fi
2492
2493	findunref -S $SCM_TYPE -t $SRC/.build.tstamp -s usr $CODEMGR_WS \
2494	    ${TOOLS}/findunref/exception_list 2>> $mail_msg_file | \
2495	    sort > $SRC/unref-${MACH}.out
2496
2497	if [ ! -f $SRC/unref-${MACH}.ref ]; then
2498		cp $SRC/unref-${MACH}.out $SRC/unref-${MACH}.ref
2499	fi
2500
2501	diff $SRC/unref-${MACH}.ref $SRC/unref-${MACH}.out >>$mail_msg_file
2502fi
2503
2504#
2505# Generate the OpenSolaris deliverables if requested.  Some of these
2506# steps need to come after findunref and are commented below.
2507#
2508
2509# Verify that the usual lists of files, such as exception lists,
2510# contain only valid references to files.  If the build has failed,
2511# then don't check the proto area.
2512CHECK_PATHS=${CHECK_PATHS:-y}
2513if [ "$CHECK_PATHS" = y -a "$N_FLAG" != y ]; then
2514	echo "\n==== Check lists of files ====\n" | tee -a $LOGFILE \
2515		>>$mail_msg_file
2516	arg=-b
2517	[ "$build_ok" = y ] && arg=
2518	checkpaths $arg $checkroot 2>&1 | tee -a $LOGFILE >>$mail_msg_file
2519fi
2520
2521if [ "$M_FLAG" != "y" -a "$build_ok" = y ]; then
2522	echo "\n==== Impact on file permissions ====\n" \
2523		>> $mail_msg_file
2524
2525	abspkgdefs=
2526	abspkg=
2527	for d in $abssrcdirs; do
2528		if [ -d "$d/pkgdefs" ]; then
2529			abspkgdefs="$abspkgdefs $d"
2530		fi
2531		if [ -d "$d/pkg" ]; then
2532			abspkg="$abspkg $d"
2533		fi
2534	done
2535
2536	if [ -n "$abspkgdefs" ]; then
2537		pmodes -qvdP \
2538		    `find $abspkgdefs -name pkginfo.tmpl -print -o \
2539		    -name .del\* -prune | sed -e 's:/pkginfo.tmpl$::' | \
2540		    sort -u` >> $mail_msg_file
2541	fi
2542
2543	if [ -n "$abspkg" ]; then
2544		for d in "$abspkg"; do
2545			( cd $d/pkg ; $MAKE -e pmodes ) >> $mail_msg_file
2546		done
2547	fi
2548fi
2549
2550if [ "$w_FLAG" = "y" -a "$build_ok" = "y" ]; then
2551	if [[ "$MULTI_PROTO" = no || "$D_FLAG" = y ]]; then
2552		do_wsdiff DEBUG $ROOT.prev $ROOT
2553	fi
2554
2555	if [[ "$MULTI_PROTO" = yes && "$F_FLAG" = n ]]; then
2556		do_wsdiff non-DEBUG $ROOT-nd.prev $ROOT-nd
2557	fi
2558fi
2559
2560END_DATE=`date`
2561echo "==== Nightly $maketype build completed: $END_DATE ====" | \
2562    tee -a $LOGFILE >> $build_time_file
2563
2564typeset -i10 hours
2565typeset -Z2 minutes
2566typeset -Z2 seconds
2567
2568elapsed_time=$SECONDS
2569((hours = elapsed_time / 3600 ))
2570((minutes = elapsed_time / 60  % 60))
2571((seconds = elapsed_time % 60))
2572
2573echo "\n==== Total build time ====" | \
2574    tee -a $LOGFILE >> $build_time_file
2575echo "\nreal    ${hours}:${minutes}:${seconds}" | \
2576    tee -a $LOGFILE >> $build_time_file
2577
2578if [ "$u_FLAG" = "y" -a "$f_FLAG" = "y" -a "$build_ok" = "y" ]; then
2579	staffer cp ${SRC}/unref-${MACH}.out $PARENT_WS/usr/src/
2580
2581	#
2582	# Produce a master list of unreferenced files -- ideally, we'd
2583	# generate the master just once after all of the nightlies
2584	# have finished, but there's no simple way to know when that
2585	# will be.  Instead, we assume that we're the last nightly to
2586	# finish and merge all of the unref-${MACH}.out files in
2587	# $PARENT_WS/usr/src/.  If we are in fact the final ${MACH} to
2588	# finish, then this file will be the authoritative master
2589	# list.  Otherwise, another ${MACH}'s nightly will eventually
2590	# overwrite ours with its own master, but in the meantime our
2591	# temporary "master" will be no worse than any older master
2592	# which was already on the parent.
2593	#
2594
2595	set -- $PARENT_WS/usr/src/unref-*.out
2596	cp "$1" ${TMPDIR}/unref.merge
2597	shift
2598
2599	for unreffile; do
2600		comm -12 ${TMPDIR}/unref.merge "$unreffile" > ${TMPDIR}/unref.$$
2601		mv ${TMPDIR}/unref.$$ ${TMPDIR}/unref.merge
2602	done
2603
2604	staffer cp ${TMPDIR}/unref.merge $PARENT_WS/usr/src/unrefmaster.out
2605fi
2606
2607#
2608# All done save for the sweeping up.
2609# (whichever exit we hit here will trigger the "cleanup" trap which
2610# optionally sends mail on completion).
2611#
2612if [ "$build_ok" = "y" ]; then
2613	exit 0
2614fi
2615exit 1
2616